Noteworthy changes in release 7.0 (2026-04-26)
==============================================

* Improvements
  * Implemented optional colorized trace output.
  * Implemented decoding of rseq and rseq_slice_yield syscalls.
  * Implemented decoding of BPF_TRACE_FSESSION bpf attach type.
  * Implemented decoding of BPF_PROG_ASSOC_STRUCT_OPS bpf command.
  * Implemented decoding of UDMABUF_CREATE, UDMABUF_CREATE_LIST,
    and VIDIOC_QUERYMENU ioctl commands.
  * Updated decoding of statmount syscall flags.
  * Updated lists of BPF_*, BTRFS_*, FS_*, IORING_*, KEY_*, KVM_*, NT_*,
    OPEN_TREE_*, PR_*, V4L2_*, and *_MAGIC constants.
  * Updated lists of ioctl commands from Linux 7.0.

Noteworthy changes in release 6.19 (2026-02-10)
===============================================

* Improvements
  * Implemented decoding of listns syscall.
  * Implemented decoding of F_GET_RW_HINT, F_SET_RW_HINT, F_GET_FILE_RW_HINT,
    F_SET_FILE_RW_HINT, F_GETDELEG, and F_SETDELEG fcntl commands.
  * Implemented decoding of IORING_REGISTER_SEND_MSG_RING,
    IORING_REGISTER_ZCRX_IFQ, IORING_REGISTER_RESIZE_RINGS,
    IORING_REGISTER_MEM_REGION, IORING_REGISTER_QUERY, and
    IORING_REGISTER_ZCRX_CTRL opcodes of io_uring_register syscall.
  * Implemented decoding of extended argument structures for io_uring_enter
    syscall when IORING_ENTER_EXT_ARG or IORING_ENTER_EXT_ARG_REG flags are set.
  * Implemented decoding of attr_ptr and attr_type_mask fields of
    struct io_uring_sqe for io_uring_register syscall.
  * Implemented opcode-specific decoding of flags union and ioprio fields
    of struct io_uring_sqe for io_uring_register syscall.
  * Implemented decoding of 128-byte SQEs for io_uring_register syscall.
  * Implemented decoding of socket operations (SOCKET_URING_OP_*) for
    io_uring URING_CMD and URING_CMD128 operations when the file descriptor
    is a socket.
  * Updated decoding of struct mnt_id_req and struct perf_event_attr.
  * Updated lists of ABS_*, BPF_*, ETHTOOL_*, ETH_P_*, IORING_*, KVM_*, PERF_*,
    TLS_*, V4L2_*, and *_MAGIC constants.
  * Updated lists of ioctl commands from Linux 6.19.

Noteworthy changes in release 6.18 (2025-12-07)
===============================================

* Improvements
  * Added -e kvm=vcpu+ option for kvm_run struct decoding.
  * Implemented decoding of FS_IOC_GETFSUUID, FS_IOC_GETFSSYSFSPATH, and
    FS_IOC_GETLBMD_CAP ioctl commands.
  * Implemented decoding of BPF_PROG_STREAM_READ_BY_FD bpf command.
  * Updated decoding of BPF_BTF_LOAD, BPF_MAP_CREATE, BPF_PROG_ATTACH,
    BPF_PROG_DETACH, BPF_PROG_LOAD, BPF_PROG_QUERY, and BPF_*_GET_*_ID bpf
    commands.
  * Updated decoding of bpf_map_info and bpf_prog_info structures.
  * Updated lists of AUDIT_*, BR_*, FF_*, IFLA_*, INPUT_PROP_*, IORING_*,
    KEXEC_FILE_*, KEY_*, KVM_CAP_*, NL80211_CMD_*, RWF_*, and TEE_* constants.

Noteworthy changes in release 6.17 (2025-09-29)
===============================================

* Improvements
  * Implemented decoding of file_getattr and file_setattr syscalls.
  * Implemented decoding of SO_INQ socket option.
  * Updated lists of BPF_*, BTN_*, BTRFS_*, DEVCONF_*, ETHTOOL_*, FALLOC_*,
    KEXEC_*, KEY_*, KVM_*, NETCONFA_*, NFT_*, PR_*, SCM_*, V4L2_*, and XDP_*
    constants.
  * Updated lists of ioctl commands from Linux 6.17.

Noteworthy changes in release 6.16 (2025-08-05)
===============================================

* Improvements
  * Added -N/--arg-names option for printing syscall argument names.
  * Implemented setting of system call information using
    PTRACE_SET_SYSCALL_INFO ptrace API introduced in Linux 6.16.
  * Implemented decoding of SO_RCVPRIORITY and SO_PASSRIGHTS socket options.
  * Implemented decoding of RTA_NH_ID and RTA_FLOWLABEL netlink attributes.
  * Updated decoding of statx syscall.
  * Updated lists of BR_*, CRYPTOCFGA_*, FUTEX2_*, IORING_*, IPSET_*, KVM_*,
    MDB_*, NETDEV_*, PR_*, RXRPC_*, SW_*, THERMAL_*, and V4L2_*
    constants.
  * Updated lists of ioctl commands from Linux 6.16.

Noteworthy changes in release 6.15 (2025-05-26)
===============================================

* Improvements
  * Implemented decoding of open_tree_attr syscall.
  * Implemented decoding of AF_TIPC socket addresses and socket options.
  * Updated decoding of statmount syscall.
  * Updated lists of AUDIT_*, BPF_*, BTRFS_*, COUNTER_*, FAN_*, FRA_*, IFLA_*,
    IORING_*, KVM_*, LANDLOCK_*, PKEY_*, RTPROT_*, TCP_*, and V4L2_* constants.
  * Updated lists of ioctl commands from Linux 6.15.

Noteworthy changes in release 6.14 (2025-03-25)
===============================================

* Improvements
  * Added -e namespace=new option for printing the namespaces entered
    by the tracee.
  * Implemented decoding of FRA_FLOWLABEL and FRA_FLOWLABEL_MASK netlink
    attributes of RTM_{NEW,DEL,GET}RULE NETLINK_ROUTE messages.
  * Implemented decoding of RTM_{NEW,DEL}MULTICAST and RTM_{NEW,DEL}ANYCAST
    NETLINK_ROUTE messages.
  * Updated decoding of statx syscall.
  * Updated lists of AT_*, AUDIT_*, ETHTOOL_*, FAN_*, IORING_*, IPPROTO_*,
    KEY_*, NL80211_*, RWF_*, and SECBIT_* constants.
  * Updated lists of ioctl commands from Linux 6.14.

Noteworthy changes in release 6.13 (2025-01-23)
===============================================

* Improvements
  * Implemented decoding of getxattrat, setxattrat, listxattrat,
    and removexattrat syscalls.
  * Updated decoding of struct io_uring_clone_buffers, struct io_uring_napi,
    and struct perf_event_attr.
  * Updated decoding of crypto_user_alg netlink attributes of NETLINK_CRYPTO.
  * Implemented decoding of IFLA_MCTP_PHYS_BINDING netlink attribute.
  * Updated lists of AT_*, BPF_*, FAN_*, IORING_*, MADV_*, NT_*, and SCM_*
    constants.
  * Updated lists of ioctl commands from Linux 6.13.

Noteworthy changes in release 6.12 (2024-11-18)
===============================================

* Improvements
  * Implemented decoding of EPIOCGPARAMS and EPIOCSPARAMS ioctl commands.
  * Implemented decoding of NS_GET_MNTNS_ID, NS_GET_PID_FROM_PIDNS,
    NS_GET_TGID_FROM_PIDNS, NS_GET_PID_IN_PIDNS, NS_GET_TGID_IN_PIDNS,
    NS_MNT_GET_INFO, NS_MNT_GET_NEXT, and NS_MNT_GET_PREV ioctl commands.
  * Implemented decoding of FRA_DSCP netlink attribute.
  * Implemented decoding of IORING_REGISTER_CLOCK and
    IORING_REGISTER_CLONE_BUFFERS opcodes of io_uring_register syscall.
  * Updated decoding of struct landlock_ruleset_attr.
  * Updated lists of AUDIT_*, ETHTOOL_*, F_*, IORING_*, LSM_*, MAP_*, MSG_*,
    NT_*, SCHED_*, SCM_*, SO_*, and V4L2_* constants.
  * Updated lists of ioctl commands from Linux 6.12.

* Bug fixes
  * Fix the syscall name printed by strace when PTRACE_GET_SYSCALL_INFO
    is in use and a syscall is restarted by a just attached tracee using
    restart_syscall mechanism.

Noteworthy changes in release 6.11 (2024-09-15)
===============================================

* Improvements
  * Implemented decoding of uretprobe syscall.
  * Implemented decoding of WDIOC_GETSUPPORT and WDIOC_SETOPTIONS ioctl
    commands.
  * Enhanced decoding of unknown ioctl commands in non-abbreviated mode
    by printing the contents of the ioctl argument buffer in hexadecimal format.
  * Updated decoding of listmount, statmount, and statx syscalls.
  * Updated lists of ETHTOOL_*, IORING_*, IPPROTO_*, RWF_*, STATX_*, and V4L2_*
    constants.
  * Updated lists of ioctl commands from Linux 6.11.

Noteworthy changes in release 6.10 (2024-07-21)
===============================================

* Improvements
  * Implemented --decode-fds=eventfd option to retrieve eventfd object details
    associated with eventfd file descriptors.
  * Implemented decoding of NETLINK_GENERIC nlctrl protocol.
  * Implemented decoding of F_DUPFD_QUERY fcntl.
  * Implemented decoding of mseal syscall.
  * Updated decoding of statx and prctl syscalls.
  * Updated decoding of BPF_RAW_TRACEPOINT_OPEN bpf command.
  * Updated lists of BPF_*, IORING_*, KEXEC_*, KEY_*, LANDLOCK_*, PR_*, STATX_*,
    TCP_*, TEE_*, V4L2_*, and *_MAGIC constants.
  * Updated lists of ioctl commands from Linux 6.10.

* Bug fixes
  * Worked around a bug introduced in Linux 6.5 that affected system call
    tampering on riscv64.

Noteworthy changes in release 6.9 (2024-05-14)
==============================================

* Improvements
  * Implemented --always-show-pid option.
  * The --user|-u option has learned to recognize numeric UID:GID pair, allowing
    e.g. statically-built strace to be used without invoking nss plugins.
  * Implemented decoding of IORING_REGISTER_SYNC_CANCEL,
    IORING_REGISTER_FILE_ALLOC_RANGE, IORING_REGISTER_PBUF_STATUS,
    IORING_REGISTER_NAPI, and IORING_UNREGISTER_NAPI opcodes of
    io_uring_register syscall.
  * Implemented decoding of BPF_TOKEN_CREATE bpf syscall command.
  * Updated decoding of io_uring_register and pidfd_send_signal syscalls.
  * Updated lists of BPF_*, CAN_*, IORING_*, KEY_*, LSM_*, MPOL_*, NT_*, RWF_*,
    PIDFD_*, PTP_*, TCP_*, and *_MAGIC constants.
  * Updated lists of ioctl commands from Linux 6.9.

Noteworthy changes in release 6.8 (2024-03-20)
==============================================

* Improvements
  * Renamed --stack-traces to --stack-trace for consistency.
    Old option is retained for backwards compatibility.
  * Implemented --stack-trace-frame-limit=N option for configuring the limit
    of the number of printed backtrace frames.
  * Implemented decoding of statmount, listmount, lsm_get_self_attr,
    lsm_set_self_attr, and lsm_list_modules syscalls.
  * Implemented decoding of setsockopt(TCP_AO_ADD_KEY).
  * Updated decoding of landlock_create_ruleset and landlock_add_rule syscalls.
  * Updated decoding of SMC_DIAG_DMBINFO netlink attribute.
  * Updated decoding of UBI_IOCATT ioctl command.
  * Enhanced decoding of mount attributes of fsmount and mount_setattr syscalls.
  * Updated lists of BPF_*, KEXEC_*, KVM_*, PERF_*, SOL_*, STATX_*, UFFD_*,
    and V4L2_* constants.
  * Updated lists of ioctl commands from Linux 6.8.

Noteworthy changes in release 6.7 (2024-01-29)
==============================================

* Improvements
  * Implemented -kk/--stack-traces=source option for libdw-based stack tracing.
  * Implemented decoding of futex_wake, futex_wait, and sys_futex_requeue
    syscalls.
  * Updated lists of BPF_*, BTRFS_*, IORING_*, KVM_*, LANDLOCK_*, PR_*,
    and TCP_* constants.
  * Updated lists of ioctl commands from Linux 6.7.

* Bug fixes
  * Fix strace -r during the first second after booting to show correct relative
    timestamps.
  * Fix strace -f entering deadlock on exit if there are tracee processes
    spawned using vfork semantics.

Noteworthy changes in release 6.6 (2023-10-31)
==============================================

* Improvements
  * Implemented --kill-on-exit option that instructs the tracer to set
    PTRACE_O_EXITKILL option to all tracee processes and not to detach them
    on cleanup so they will not be left running after the tracer exit.
  * Implemented automatic activation of --kill-on-exit option when
    --seccomp-bpf is enabled and -p/--attach option is not used.
  * Implemented decoding of map_shadow_stack syscall.
  * Implemented decoding of FSCONFIG_CMD_CREATE_EXCL fsconfig command.
  * Implemented decoding of IFLA_BRPORT_BACKUP_NHID netlink attribute.
  * Implemented decoding of SECCOMP_IOCTL_NOTIF_SET_FLAGS ioctl.
  * Implemented decoding of UFFDIO_CONTINUE, UFFDIO_POISON, and
    UFFDIO_WRITEPROTECT ioctls.
  * Updated lists of ARCH_*, BPF_*, DEVCONF_*, IORING_*, KEXEC_*, MAP_*, NT_*,
    PTRACE_*, QFMT_*, SEGV_*, UFFD_*, V4L2_*, and XDP_* constants.
  * Updated lists of ioctl commands from Linux 6.6.

Noteworthy changes in release 6.5 (2023-09-01)
==============================================

* Improvements
  * Implemented decoding of cachestat and fchmodat2 syscalls.
  * Implemented decoding of SO_PASSPIDFD and SO_PEERPIDFD socket options.
  * Implemented decoding of SCM_PIDFD control messages.
  * Implemented decoding of BPF_ENABLE_STATS, BPF_ITER_CREATE, BPF_LINK_DETACH,
    and BPF_PROG_BIND_MAP bpf syscall commands.
  * Updated decoding of BPF_OBJ_PIN and BPF_OBJ_GET bpf syscall commands.
  * Updated lists of AT_*, BPF_*, IORING_*, KVM_*, MOVE_MOUNT_*, NFT_*, NT_*,
    PR_*, and V4L2_* constants.
  * Updated lists of ioctl commands from Linux 6.5.

Noteworthy changes in release 6.4 (2023-06-26)
==============================================

* Improvements
  * Implemented decoding of IFLA_BRPORT_NEIGH_VLAN_SUPPRESS netlink attribute.
  * Implemented decoding of IP_PROTOCOL type control messages and socket option.
  * Updated lists of BPF_*, IP_*, KVM_*, MDBA_*, PACKET_*, PR_*, PTRACE_*,
    UFFD_*, and V4L2_PIX_FMT_* constants.
  * Updated lists of ioctl commands from Linux 6.4.

* Bug fixes
  * Turn --seccomp-bpf off when --syscall-limit option is specified.
  * Fixed --trace-fds filtering support of syscalls taking file descriptor
    arguments that do not normally have a path associated with them.

Noteworthy changes in release 6.3 (2023-05-08)
==============================================

* Improvements
  * Implemented --trace-fds=set option for filtering only the syscalls
    that operate on the specified set of file descriptors.
  * Implemented --decode-fds=signalfd option for decoding of signal masks
    associated with signalfd file descriptors.
  * Implemented --syscall-limit option to automatically detach tracees
    after capturing the specified number of syscalls.
  * Implemented --argv0 option to set argv[0] of the command being executed.
  * Implemented decoding of PR_GET_MDWE and PR_SET_MDWE operations of prctl
    syscall.
  * Implemented decoding of IP_LOCAL_PORT_RANGE socket option.
  * Implemented decoding of IFLA_BRPORT_MCAST_N_GROUPS,
    IFLA_BRPORT_MCAST_MAX_GROUPS, IFLA_GSO_IPV4_MAX_SIZE,
    IFLA_GRO_IPV4_MAX_SIZE, and TCA_EXT_WARN_MSG netlink attributes.
  * Updated lists of F_SEAL_*, IFLA_*, IORING_*, MFD_*, NFT_*, TCA_*,
    and V4L2_PIX_FMT_* constants.
  * Updated lists of ioctl commands from Linux 6.3.

* Bug fixes
  * Fixed build on hppa with uapi headers from Linux >= 6.2.
  * Fixed --status filtering when -c option is in use.

Noteworthy changes in release 6.2 (2023-02-26)
==============================================

* Improvements
  * Implemented collision resolution for overlapping ioctl commands
    from tty and snd subsystems.
  * Implemented decoding of IFLA_BRPORT_MAB and IFLA_DEVLINK_PORT
    netlink attributes.
  * Updated lists of ALG_*, BPF_*, IFLA_*, KEY_*, KVM_*, LANDLOCK_*,
    MEMBARRIER_*, NFT_*, NTF_*, and V4L2_* constants.
  * Updated lists of ioctl commands from Linux 6.2.

* Bug fixes
  * Fixed build on alpha architecture.

Noteworthy changes in release 6.1 (2022-12-12)
==============================================

* Improvements
  * Enhanced decoding of terminal ioctl commands.
  * Updated decoding of statx syscall.
  * Updated lists of ABS_*, BPF_*, BTRFS_*, COUNTER_*, ETH_P_*, IFLA_*,
    KVM_*, MADV_*, NLMSGERR_*, PERF_*, STATX_*, and TLS_* constants.
  * Updated lists of ioctl commands from Linux 6.1.

* Bug fixes
  * Fixed injection tests on ia64.

Noteworthy changes in release 6.0 (2022-10-29)
==============================================

* Improvements
  * Enhanced decoding of PTP_* ioctl commands.
  * Updated decoding of setns syscall.
  * Updated lists of BPF_*, BTRFS_*, FAN_*, ETH_P_*, KVM_*, NDTPA_*,
    NT_*, PERF_*, and TLS_INFO_* constants.
  * Updated lists of ioctl commands from Linux 6.0.

Noteworthy changes in release 5.19 (2022-08-12)
===============================================

* Changes in behaviour
  * The "(deleted)" marker for unlinked paths of file descriptors is now printed
    outside angle brackets;  the matching of unlinked paths of file descriptors
    no longer includes the " (deleted)" part into consideration.

* Improvements
  * Implemented printing of Unix socket sun_path field's SELinux context.
  * Implemented decoding of SO_TXREHASH socket option.
  * Implemented decoding of IFLA_TSO_MAX_SIZE, IFLA_TSO_MAX_SEGS,
    NDA_FDB_EXT_ATTRS, NDA_FLAGS_EXT, NDA_NDM_FLAGS_MASK,
    and NDA_NDM_STATE_MASK netlink attributes.
  * Improved decoding of INET_DIAG_LOCALS, INET_DIAG_MD5SIG, INET_DIAG_PEERS,
    INET_DIAG_PROTOCOL, INET_DIAG_REQ_PROTOCOL, INET_DIAG_SHUTDOWN,
    INET_DIAG_SK_BPF_STORAGES, INET_DIAG_SOCKOPT, and INET_DIAG_ULP_INFO
    NETLINK_SOCK_DIAG netlink attributes.
  * Enhanced decoding of arch_prctl and prctl syscalls.
  * Enhanced siginfo_t decoding.
  * Updated decoding of struct rtnl_link_stats64.
  * Updated lists of DEVCONF_*, FAN_MARK_*, GPIO_V2_LINE_FLAG_*, IORING_*,
    KEXEC_*, LANDLOCK_*, NET_IPV4_CONF_*, NLM_F_*, NT_*, PR_*, SECCOMP_*,
    UFFD_FEATURE_*, V4L2_CID_*, and V4L2_PIX_FMT_* constants.
  * Updated lists of ioctl commands from Linux 5.19.

Noteworthy changes in release 5.18 (2022-06-18)
===============================================

* Improvements
  * Added an interface of raising des Strausses awareness.
  * Added --tips option to print strace tips, tricks, and tweaks
    at the end of the tracing session.
  * Enhanced decoding of bpf and io_uring_register syscalls.
  * Implemented decoding of COUNTER_*, RTC_PARAM_GET, and RTC_PARAM_SET ioctl
    commands.
  * Updated lists of BPF_*, BR_*, BTRFS_*, IFA_*, IFLA_*, IORING_*, KEY_*,
    KVM_*, MADV_*, and UFFD_* constants.
  * Updated lists of ioctl commands from Linux 5.18.

* Bug fixes
  * Fixed printing of the updated value of union bpf_attr.next_id
    on the exiting of bpf(BPF_*_GET_NEXT_ID) calls.

Noteworthy changes in release 5.17 (2022-03-26)
===============================================

* Improvements
  * Added 64-bit LoongArch architecture support.
  * Extended personality designation syntax of syscall specification expressions
    to support all@pers and %class@pers.
  * Enhanced rejection of invalid syscall numbers in syscall specification
    expressions.
  * Implemented decoding of set_mempolicy_home_node syscall, introduced
    in Linux 5.17.
  * Implemented decoding of IFLA_GRO_MAX_SIZE and TCA_ACT_IN_HW_COUNT netlink
    attributes.
  * Implemented decoding of PR_SET_VMA operation of prctl syscall.
  * Implemented decoding of siginfo_t.si_pkey field.
  * Implemented decoding of LIRC ioctl commands.
  * Updated lists of FAN_*, IORING_*, IOSQE_*, KEY_*, KVM_*, MODULE_INIT_*,
    TCA_ACT_*, and *_MAGIC constants.
  * Updated lists of ioctl commands from Linux 5.17.

Noteworthy changes in release 5.16 (2022-01-10)
===============================================

* Improvements
  * Implemented --secontext=mismatch option to find mismatches in SELinux
    contexts.
  * Implemented decoding of futex_waitv syscall introduced in Linux 5.16.
  * Implemented decoding of BPF_LINK_GET_NEXT_ID and BPF_LINK_GET_FD_BY_ID bpf
    syscall commands.
  * Enhanced decoding of BPF_MAP_CREATE, BPF_PROG_TEST_RUN, and BPF_PROG_LOAD
    bpf syscall commands.
  * Enhanced decoding of BTRFS_IOC_FS_INFO ioctl command.
  * Updated lists of AUDIT_*, BPF_*, BTRFS_*, DEVCONF_*, FAN_*, ETH_P_*,
    IPV4_DEVCONF_*, KVM_*, NDA_*, SO_*, and V4L2_* constants.
  * Updated lists of ioctl commands from Linux 5.16.

* Bug fixes
  * Fixed build for older Android.

Noteworthy changes in release 5.15 (2021-12-01)
===============================================

* Improvements
  * Implemented --strings-in-hex=non-ascii-chars option for using hexadecimal
    numbers instead of octal ones in escape sequences in the output strings.
  * Implemented --decode-pids=comm option (and its alias -Y) for printing
    command names for PIDs.
  * Implemented --decode-pids=pidns as an alias to --pidns-translation option.
  * Implemented printing of current working directory when AT_FDCWD constant
    is used with --decode-fds=path option enabled.
  * Improved printing of syscall names in places where the associated
    AUDIT_ARCH_* value is present (ptrace PTRACE_GET_SYSCALL_INFO request,
    SIGSYS siginfo_t).
  * Implemented decoding of process_mrelease syscall, introduced in Linux 5.15.
  * Implemented decoding of SECCOMP_GET_NOTIF_SIZES operation of seccomp
    syscall.
  * Implemented decoding of HDIO_*, KD*, and SECCOMP_* ioctl commands.
  * Implemented decoding of RTM_NEWCACHEREPORT, RTM_{NEW,DEL,GET}NEXTHOP,
    and RTM_{NEW,GET}STATS NETLINK_ROUTE netlink messages.
  * Implemented decoding of AF_ALG, AF_IEEE802154, AF_MCTP, AF_NFC, AF_QIPCRTR,
    AF_RRPC, AF_VSOCK, and AF_XDP socket addresses.
  * Implemented decoding of AF_BRIDGE and AF_MCTP protocols for IFLA_AF_SPEC
    netlink attribute.
  * Implemented decoding of IFLA_BR_MCAST_QUERIER_STATE, IFLA_BR_MULTI_BOOLOPT,
    IFLA_INET6_RA_MTU, IFLA_INFO_SLAVE_DATA, and IFLA_VFINFO_LIST netlink
    attributes.
  * Enhanced decoding of io_uring_register and times syscalls.
  * Enhanced IFLA_BR_FORWARD_DELAY, IFLA_BR_MAX_AGE, IFLA_EXT_MASK,
    IFLA_PROTINFO, *_INTVL, and *_TIMER netlink attribute decoding.
  * Enhanced decoding of AF_IPX and AF_NETLINK socket addresses.
  * Updated lists o AF_*, ARPHRD_*, BTRFS_*, DEVCONF_*, DM_*, ETH_P_*,
    FAN_REPORT_*, IORING_*, MOVE_MOUNT_*, MPOL_*, PACKET_*, RTM_*, SO_*,
    and XFRM_MSG_* constants.
  * Updated lists of ioctl commands from Linux 5.15.

* Bug fixes
  * Fixed printing of struct bpf_prog_info.map_ids array.
  * Fixed behaviour of "dev", "pidfd", and "socket" arguments of the --print-fds
    option to no longer imply the "path" argument.
  * Fixed insufficient buffer size used for network interface name printing,
    that previously led to assertions on attempts of printing interface names
    that require quoting, for example, names longer than 4 characters in -xx
    mode (addresses RHBZ bug #2028146).

Noteworthy changes in release 5.14 (2021-09-02)
===============================================

* Improvements
  * Implemented decoding of memfd_secret and quotactl_fd syscalls,
    introduced in Linux 5.14.
  * Enhanced prctl syscall decoding.
  * Enhanced decoding of IFLA_* netlink attributes.
  * Enhanced decoding of MDBA_ROUTER_PATTR_* mdb router port netlink attributes.
  * Updated lists of BPF_*, IORING_*, MADV_*, MOUNT_ATTR_*, SCTP_*,
    and UFFD_* constants.
  * Updated lists of ioctl commands from Linux 5.14.

* Bug fixes
  * Fixed build using bionic libc.

Noteworthy changes in release 5.13 (2021-07-18)
===============================================

* Improvements
  * Print netlink data in a more structured way.
  * Implemented decoding of NT_PRSTATUS and NT_FPREGSET regsets
    of PTRACE_GETREGSET and PTRACE_SETREGSET requests.
  * Implemented decoding of regs argument of PTRACE_GETREGS, PTRACE_GETREGS64,
    PTRACE_SETREGS, PTRACE_SETREGS64, PTRACE_GETFPREGS, and PTRACE_SETFPREGS
    requests.
  * Implemented powerpc System Call Vectored ABI support.
  * Implemented decoding of landlock_add_rule, landlock_create_ruleset,
    and landlock_restrict_self syscalls introduced in Linux 5.13.
  * Enhanced decoding of perf_event_open syscall.
  * Updated lists of BPF_*, IORING_*, KEXEC_*, KEY_*, KVM_*, NT_*, PR_*,
    PTRACE_*, RTM_*, RTPROT_*, TRAP_*, UFFD_*, UFFDIO_*, and V4L2_* constants.
  * Updated lists of ioctl commands from Linux 5.13.

* Portability
  * On powerpc and powerpc64, linux kernel >= 2.6.23 is required.
    Older versions without a decent PTRACE_GETREGS support will not work.

Noteworthy changes in release 5.12 (2021-04-26)
===============================================

* Improvements
  * Implemented --secontext[=full] option to display SELinux contexts.
  * Implemented decoding of mount_setattr syscall introduced in Linux 5.12.
  * Updated decoding of IFLA_BRPORT_* netlink attributes to match Linux 5.12.
  * Updated lists of DEVCONF_*, IORING_*, KVM_*, MPOL_*, MTD_*, NFT_MSG_*,
    RESOLVE_*, RTM_*, ST_*, and V4L2_* constants.
  * Updated lists of ioctl commands from Linux 5.12.

* Bug fixes
  * Fixed build using bionic libc.

* Portability
  * Added binutils 2.36 support to --enable-mpers builds.

Noteworthy changes in release 5.11 (2021-02-17)
===============================================

* Improvements
  * Implemented poke injection (--inject=SET:poke_enter= and
    --inject=SET:poke_exit= options).
  * Implemented decoding of epoll_pwait2 syscall introduced in Linux 5.11.
  * Implemented decoding of GPIO_* ioctl commands.
  * Implemented decoding of FS_IOC_FS[GS]ETXATTR, FS_IOC_[GS]ETFLAGS,
    and FS_IOC32_[GS]ETFLAGS ioctl commands.
  * Implemented decoding of SIOCADDMULTI, SIOCDELMULTI, SIOCGIFENCAP,
    SIOCOUTQNSD, SIOCSIFENCAP, and SIOCSIFHWBROADCAST ioctl commands.
  * Implemented decoding of UBI_IOCRPEB and UBI_IOCSPEB ioctl commands.
  * Implemented decoding of V4L2_BUF_TYPE_META_CAPTURE,
    V4L2_BUF_TYPE_META_OUTPUT, and VIDIOC_QUERY_EXT_CTRL ioctl commands.
  * Updated lists of BPF_*, BTRFS_*, CLOSE_RANGE_*, ETH_*, IORING_*, KVM_*,
    PR_*, PTRACE_*, RTA_*, RTAX_*, RTM_*, RTNH_*, SCTP_*, SO_*, SYS_*, UFFD_*,
    and V4L2_* constants.
  * Updated lists of ioctl commands from Linux 5.11.

* Bug fixes
  * Fixed decoding of SIOCGIFINDEX, SIOCBRADDIF, and SIOCBRDELIF ioctl commands.
  * Fixed decoding of FIO[GS]ETOWN, SIOC[GS]PGRP, and SIOCATMARK ioctl commands
    on alpha, mips, sh, and xtensa architectures.
  * Fixed fork--pidns-translation test on sparc and sparc64.
  * Fixed build on hppa with uapi headers from Linux >= 5.10.

Noteworthy changes in release 5.10 (2020-12-14)
===============================================

* Improvements
  * libdw-based stack tracing is now enabled for non-native personalities.
  * Implemented decoding of process_madvise syscall introduced in Linux 5.10.
  * Updated decoding of pidfd_open syscall to match Linux 5.10.
  * Updated decoding of membarrier syscall to match Linux 5.10.
  * Updated lists of ALG_*, BPF_*, INET_DIAG_*, IORING_*, KEY_*, KVM_*, MDBA_*,
    MEMBARRIER_CMD_*, MS_*, NLMSGERR_*, NT_*, STATX_*, SEGV_*, and V4L2_*
    constants.
  * Updated lists of ioctl commands from Linux 5.10.

* Bug fixes
  * Added clock_gettime64, clock_settime64, clock_adjtime64, and
    lock_getres_time64 syscalls to %clock trace class.

* Portability
  * Implemented workarounds for -Wall regressions in Red Hat gcc 11.0.0-0.

Noteworthy changes in release 5.9 (2020-09-24)
==============================================

* Improvements
  * Added -n/--syscall-number option for printing syscall numbers.
  * Added --pidns-translation option for PID namespace translation (addresses
    Fedora bug #1035433).
  * Implemented decoding of close_range syscall.
  * Implemented decoding of TEE_* ioctl commands.
  * Implemented decoding of struct msginfo argument of IPC_INFO
    and MSG_INFO msgctl syscall commands.
  * Implemented decoding of struct msqid_ds argument of MSG_STAT
    and MSG_STAT_ANY msgctl syscall commands.
  * Implemented decoding of struct seminfo argument of IPC_INFO
    and SEM_INFO semctl syscall commands.
  * Implemented decoding of struct semid_ds argument of IPC_SET,
    IPC_STAT, SEM_STAT, and SEM_STAT_ANY semctl syscall commands.
  * Implemented decoding of struct shminfo argument of IPC_INFO
    shmctl syscall command.
  * Implemented decoding of struct shm_info argument of SHM_INFO
    shmctl syscall command.
  * Implemented decoding of struct shmid_ds argument of SHM_STAT
    and SHM_STAT_ANY shmctl syscall commands.
  * Updated lists of BPF_*, CAP_*, FAN_*, IFLA_*, INET_DIAG_REQ_*,
    IORING_FEAT_*, IP_*, IPV6_*, KVM_*, NDA_*, PTP_PEROUT_*, RTPROT_*,
    and V4L2_FMT_FLAG_* constants.
  * Updated lists of ioctl commands from Linux 5.9.

Noteworthy changes in release 5.8 (2020-08-06)
==============================================

* Changes in behaviour
  * Modified %process class to contain system calls associated with
    process lifecycle (creation, exec, termination):
    kill, tkill, tgkill, pidfd_send_signal and rt_sigqueueinfo are added,
    arch_prctl and unshare are removed.

* Improvements
  * Implemented decoding of faccessat2 syscall.
  * Implemented decoding of LOOP_CONFIGURE ioctl command.
  * Updated decoding of io_uring_setup syscall to match Linux 5.8.
  * Updated lists of AUDIT_*, BPF_*, CAP_*, ETH_*, INET_DIAG_*, IORING_*,
    KEYCTL_*, KVM_*, LOOP_*, NDA_*, RTC_*, TCA_*, STATX_*, and *_MAGIC
    constants.
  * Updated lists of ioctl commands from Linux 5.8.

* Bug fixes
  * Added statx syscall to %fstat trace class.

Noteworthy changes in release 5.7 (2020-06-01)
==============================================

* Improvements
  * Implemented interval specification in "when=" subexpression of syscall
    tampering expressions.
  * Added -e trace=%clock option for tracing syscalls reading or modifying
    system clocks.
  * Implemented decoding of BPF_LINK_CREATE and BPF_LINK_UPDATE bpf
    syscall commands.
  * Updated decoding of clone3 syscall to match Linux 5.7.
  * Updated lists of BPF_*, BTRFS_*, CLONE_*, FAN_*, IORING_*, KVM_*,
    LWTUNNEL_*, MREMAP_*, PERF_*, SECCOMP_*, UFFDIO_*, V4L2_*, and XDP_*
    constants.
  * Updated lists of ioctl commands from Linux 5.7.

* Bug fixes
  * Fixed decoding of getdents and getdents64 syscalls when they return
    a lot of directory entries.
  * Fixed pathtrace matching of openat2 syscall.
  * Fixed build on systems without fork.

Noteworthy changes in release 5.6 (2020-04-07)
==============================================

* Changes in behaviour
  * Messages about unknown tracees are now subject to the strace's quietness
    setting (-q/--quiet).
  * If -A option is provided without -o, or -S option without -c/-C, a warning
    about its uselessness is printed now.
  * The usage of --seccomp-bpf without -f has no effect now.

* Improvements
  * Every short option now has a long option alias, which also has enabled
    the following improvements:
    * Ability to use human-readable settings for -I/--interruptible,
      -D/--daemonize options.
    * Ability to silence specific messages using -e quiet/--quiet qualifier
      (an alias for the -q option), including those that couldn't be silenced
      previously (path resolution messages and "superseded by execve").
    * Ability to specify selected fd decoding features using
      -e decode-fds/--decode-fds qualifier (an alias for the -y option).
    * Ability to set precision for the absolute timestamp, relative timestamp,
      and syscall time output (using --absolute-timestamps,
      --relative-timestamps, and --syscall-times options, respectively).
  * Implemented ability to select the set of displayed columns in the call
    summary output (-U/--summary-columns option).
  * Implemented ability to sort on any summary column.
  * Implemented ability to show information about minimum and maximum call
    duration in the call summary output (addresses Debian bug #240945).
  * Implemented printing of PIDs associated with pidfds in -yy mode.
  * Implemented PTRACE_GETREGS API support on hppa, sh, sh64, and xtensa.
  * Improved performance of libdw-based stack traces printing by implementing
    a symbol-to-address cache.
  * Implemented decoding of openat2 and pidfd_getfd syscalls.
  * Enhanced io_uring_register, prctl, sched_getattr, and sched_setattr syscall
    decoding.
  * Implemented decoding of BPF_MAP_LOOKUP_BATCH,
    BPF_MAP_LOOKUP_AND_DELETE_BATCH, BPF_MAP_UPDATE_BATCH, and
    BPF_MAP_DELETE_BATCH bpf syscall commands.
  * Enhanced decoding of BPF_MAP_CREATE and BPF_PROG_ATTACH bpf syscall
    commands.
  * Enhanced decoding of RTC_VL_READ ioctl command.
  * Enhanced decoding of IFLA_* netlink attributes.
  * Implemented HIDIOCGRAWUNIQ() ioctl command number printing.
  * Wired up kexec_file_load syscall on hppa.
  * Updated lists of AUDIT_*, BPF_*, CLONE_*, GRND_*, IFLA_*, IORING_*,
    IPPROTO_*, KEY_*, KVM_*, RTM_F_*, SCHED_*, and *_MAGIC constants.
  * Updated lists of ioctl commands from Linux 5.6.

* Bug fixes
  * Fixed build on csky abiv1 architecture.
  * Various minor fixes in VIDIOC_* ioctl output formatting.
  * Fix printing of the size field for _IOC_NONE ioctl command numbers on sparc.

* Portability
  * On hppa, linux kernel >= 4.7 is required.
    On sh and sh64, linux kernel >= 2.6.28 is required.
    Older versions without a decent PTRACE_GETREGS support will not work.

Noteworthy changes in release 5.5 (2020-02-06)
==============================================

* Improvements
  * Added -e trace=%creds option for tracing syscalls related to process
    credentials.
  * Enhanced decoding of arch_prctl, keyctl, io_uring_register, io_uring_setup,
    and perf_event_open syscalls.
  * Enhanced decoding of BPF_PROG_LOAD bpf syscall command.
  * Updated decoding of clone3 syscall to match Linux 5.5.
  * Implemented decoding of TCA_ACT_FLAGS and TCA_STATS_PKT64 netlink
    attributes.
  * Updated lists of AUDIT_*, BPF_*, CLONE_*, KEY_*, KVM_*, PPC_PTRACE_*,
    SCTP_*, STATX_*, TIPC_*, V4L2_*, and *_MAGIC constants.
  * Updated lists of ioctl commands from Linux 5.5.
  * Enhanced manual page and "strace --help" output.

* Bug fixes
  * Fixed stack trace printing for early syscalls when strace is configured
    to use libdw backend for stack tracing (addresses Fedora bug #1788636).
  * Fixed stack trace caching when --seccomp-bpf option is specified.
  * Fixed potentially unaligned access in decoder of SO_TIMESTAMP*_NEW
    control messages.
  * Fixed decoding of NDA_LLADDR netlink neighbor table attribute.
  * Fixed build of mpers support when CFLAGS contains -flto.
  * Fixed build on no-MMU architectures.
  * Fixed build with glibc-2.31 and Linux kernel headers < 5.3.
  * Fixed tests for glibc-2.31.

Noteworthy changes in release 5.4 (2019-11-28)
==============================================

* Improvements
  * Implemented -DD and -DDD options that move strace into a separate
    process group and session, respectively.
  * Enhanced seccomp-bpf tracee syscall filtering support by implementing
    new "binary match" BPF program generation strategy and automatically
    choosing the strategy that generates the shortest BPF program.
  * Implemented decoding of BPF_BTF_GET_NEXT_ID bpf syscall command.
  * Enhanced decoding of BPF_MAP_LOOKUP_ELEM bpf syscall command.
  * Implemented PTP_CLOCK_GETCAPS2, PTP_EXTTS_REQUEST2, PTP_PEROUT_REQUEST2,
    PTP_ENABLE_PPS2, and PTP_SYS_OFFSET2 ioctl decoding.
  * Updated lists of BPF_*, CAN_*, KEXEC_*, KVM_*, MADV_*, MSG_*, P_*, PR_*,
    PTP_*, SCTP_*, and V4L2_* constants.
  * Implemented ability to build ARM EABI mpers support using a separate
    compiler on aarch64.
  * Updated lists of ioctl commands from Linux 5.4.
  * Enhanced manual page.

* Bug fixes
  * Fixed -b execve when --seccomp-bpf option is specified.
  * Fixed decoding of BPF_PROG_LOAD bpf syscall command.
  * Fixed build on no-MMU architectures.
  * Fixed build on antique systems that do not provide necessary definitions
    of AUDIT_ARCH_* constants.

Noteworthy changes in release 5.3 (2019-09-25)
==============================================

* Improvements
  * Implemented usage of seccomp-bpf for stopping tracees only for filtered
    syscalls.  Use --seccomp-bpf option to enable.
  * Implemented decoding of pidfd_open and clone3 syscalls.
  * Enhanced decoding of io_cancel, io_submit, s390_sthyi, and syslog syscalls.
  * Enhanced decoding of NETLINK_ROUTE protocol.
  * Implemented decoding of UNIX_DIAG_UID netlink attribute.
  * Implemented decoding of WDIOC_* ioctl commands.
  * Enhanced syscall count statistics: overhead is now applied per-call,
    added ability for sorting on errors field.
  * Syscall delay injection and overhead values can now be supplied with
    time measure unit suffix and provided in IEEE 754 floating point format.
  * Updated lists of AUDIT_*, BPF_*, ETH_*, KEYCTL_*, KVM_*, MAP_*, SO_*, TCP_*, V4L2_*,
    XDP_*, and *_MAGIC constants.
  * Updated lists of ioctl commands from Linux 5.3.
  * Enhanced manual page.

* Bug fixes
  * Fixed syscall tampering on arc, avr32, csky, ia64, m68k, metag, mips,
    nios2, or1k, riscv, s390, s390x, sparc, sparc64, and tile architectures
    when PTRACE_GET_SYSCALL_INFO is in use.
  * Fixed decoding of sockaddr_hci (AF_BLUETOOTH) addresses that lack
    hci_channel field.
  * Fixed evdev ioctl bitset decoding.
  * Fixed tests on alpha with Linux kernel headers 5.1+.

* Portability
  * Removed support for decoding syscalls in range [1024...1079] on AArch64
    architecture as this range has never been implemented in mainline kernel
    releases.

Noteworthy changes in release 5.2 (2019-07-12)
==============================================

* Improvements
  * Implemented syscall return status filtering with -e status=set option
    and its aliases: -z (limit syscall printing to successful syscalls only)
    and -Z (limit syscall printing to failed syscalls only).  Addresses Debian
    bug #176376.
  * Implemented decoding of open_tree, move_mount, fsopen, fsconfig, fsmount,
    and fspick syscalls.
  * Enhanced decoding of bpf, clone, inotify_init, mbind, and set_mempolicy
    syscalls.
  * Updated lists of AT_*, AUDIT_*, BPF_*, CLONE_*, ETH_*, KEY_*, KVM_*, MPOL_*,
    TIPC_*, and V4L2_* constants.
  * Updated lists of ioctl commands from Linux 5.2.

* Bug fixes
  * Fixed syscall tampering on powerpc and powerpc64 when
    PTRACE_GET_SYSCALL_INFO is in use.
  * Fixed build with cutting-edge toolchain.

Noteworthy changes in release 5.1 (2019-05-22)
==============================================

* Bug fixes
  * Fixed decoding of last two arguments of clone syscall on riscv.

* Improvements
  * Added C-SKY architecture support.
  * Implemented decoding of SO_TIMESTAMP*_NEW control messages.
  * Implemented decoding of clock_gettime64, clock_settime64, clock_adjtime64,
    clock_getres_time64, clock_nanosleep_time64, timer_gettime64,
    timer_settime64, timerfd_gettime64, timerfd_settime64, utimensat_time64,
    pselect6_time64, ppoll_time64, io_pgetevents_time64, recvmmsg_time64,
    mq_timedsend_time64, mq_timedreceive_time64, semtimedop_time64,
    rt_sigtimedwait_time64, futex_time64, sched_rr_get_interval_time64,
    pidfd_send_signal, io_uring_setup, io_uring_enter, and io_uring_register
    syscalls.
  * Enhanced decoding of bpf syscall.
  * Wired up getegid, geteuid, getppid, io_pgetevents, statfs64, and fstatfs64
    syscalls on alpha.
  * Wired up kexec_file_load and migrate_pages syscalls on arm.
  * Wired up io_pgetevents, perf_event_open, seccomp, and statx syscalls
    on ia64.
  * Wired up seccomp syscall on m68k.
  * Wired up statx syscall on sh.
  * Wired up pkey_mprotect, pkey_alloc, and pkey_free syscalls on alpha, hppa,
    ia64, m68k, s390, s390x, sh, sparc, and sparc64.
  * Wired up rseq syscall on alpha, hppa, ia64, m68k, sh, sparc, sparc64,
    and xtensa.
  * Wired up direct ipc syscalls on m68k, mips o32, powerpc, powerpc64,
    s390, s390x, sh, sparc, sparc64, and x86.
  * Updated lists of BPF_*, FAN_*, F_SEAL_*, IPV6_*, NT_*, PR_SPEC_*, SO_*,
    and V4L2_* constants.
  * Updated lists of ioctl commands from Linux 5.1.

Noteworthy changes in release 5.0 (2019-03-19)
==============================================

* Changes in behavior
  * -D option now implies -I4: by default strace ignores SIGHUP, SIGINT,
    SIGQUIT, SIGPIPE, SIGTERM, SIGTTIN, SIGTTOU, and SIGTSTP when -D option
    is used.
  * Diagnostic message is no longer printed if an attempt to restart a process
    has failed with ESRCH.  (Addresses RHBZ bug #1662936.)
  * ASCII dump no longer tries to read the whole buffer at once.  As result,
    it can fail with a diagnostic message after dumping only a part.
    Amount of preceding zeroes printed for offset is now chosen in a way
    to accommodate all the digits of all the offsets being printed.

* Improvements
  * Changed the way tracees are handled: all pending tracees are now waited for
    before further processing, this improves fairness of tracee processing.
    (Addresses RHBZ bugs #478419, #526740, #851457, #1609318, #1610774,
    and maybe some others.)
  * Enhanced xlat styles support configured by -X option.
  * Enhanced decoding of bpf syscall.
  * Enhanced decoding of PTRACE_PEEKUSER and PTRACE_POKEUSER on hppa.
  * Enhanced pid formatting in strace-log-merge output.
  * Wired up kexec_file_load and rseq syscalls on aarch64, arc, metag, nios2,
    or1k, riscv, and tile architectures.
  * Updated lists of BPF_*, BTRFS_*, FAN_*, IFLA_*, KERN_*, KVM_CAP_*, NDA_*,
    NETNSA_*, NT_*, PR_*, REL_*, SECCOMP_*, SCTP_*, UDP_*, V4L2_*, and *_MAGIC
    constants.
  * Updated lists of ioctl commands from Linux 5.0.

* Bug fixes
  * Fixed ordering of sockaddr_in6 fields.
  * Fixed strace-k test on alpha.
  * Fixed build on mips o32.
  * Fixed build on NOMMU architectures.
  * Fixed build in --with-libiberty=yes mode.
  * Fixed potential NULL dereference during printing of line continuation
    for syscalls that haven't been decoded.
  * Fixed strace-log-merge error diagnostics.

Noteworthy changes in release 4.26 (2018-12-26)
===============================================

* License
  * The test suite is now provided under the terms of
    the GNU General Public License version 2 or later.
  * All the rest of strace is now provided under the terms of
    the GNU Lesser General Public License version 2.1 or later.

* Changes in behavior
  * If strace is interrupted by a signal it handles (currently
    one of HUP, INT, QUIT, PIPE, or TERM), strace terminates
    itself with this signal.

* Improvements
  * Implemented obtainment of system call information using
    PTRACE_GET_SYSCALL_INFO ptrace API.
  * Implemented decoding of PTRACE_GET_SYSCALL_INFO ptrace request.
  * Implemented decoding of BLKGETZONESZ, BLKGETNRZONES, and RND* ioctl
    commands.
  * Enhanced xlat styles support configured by -X option.
  * Enhanced internet address formatting in structureless contexts.
  * Enhanced decoding of getsockopt SO_ERROR option.
  * Enhanced error diagnostics when the first exec fails.
  * Added %net as a short form of %network in syscall specifications.
  * Updated lists of ABS_*, BPF_*, FAN_*, IFA_*, IFLA_*, KVM_CAP_*, NETLINK_*,
    NTF_*, PR_SPEC_*, REL_*, SOL_*, TCA_*, and V4L2_* constants.
  * Updated lists of ioctl commands from Linux 4.20.
  * Enhanced manual page.

* Bug fixes
  * Fixed "xlat_idx: Unexpected xlat value 0" warnings.
  * Fixed sthyi output format on s390.
  * Documented -X option in strace -h output.

Noteworthy changes in release 4.25 (2018-10-30)
===============================================

* Improvements
  * Implemented decoding of KVM_CHECK_EXTENSION and NBD_* ioctl commands.
  * Implemented decoding of SOL_XDP socket option names.
  * Implemented decoding of AF_PACKET protocols in socket syscall.
  * Implemented decoding of AF_AX25 and AF_X25 addresses, protocols,
    and options.
  * Implemented stack trace printing on receiving signals.
  * Enhanced xlat styles support configured by -X option.
  * Enhanced decoding of IFLA_*, NETCONFA_*, and SMC_DIAG_* netlink attributes.
  * Wired up io_pgetevents syscall on arm, sparc, and sparc64.
  * Updated lists of AF_*, AUDIT_*, BPF_*, IFLA_*, IN_*, IPSTATS_*,
    IPV4_DEVCONF_*, NT_*, SCTP_*, SO_*, SOCK_*, SOL_*, and V4L2_* constants.
  * Updated lists of ioctl commands from Linux 4.19.

* Bug fixes
  * Fixed decoding of bit sets in evdev ioctl commands.
  * Fixed decoding of EVIOCGBIT(0, ...) ioctl commands.
  * Fixed test suite for the case when mlockall and unimplemented syscalls
    are explicitly disabled by a seccomp filter.

Noteworthy changes in release 4.24 (2018-08-14)
===============================================

* Improvements
  * Implemented decoding of kvm vcpu exit reason (-e kvm=vcpu option),
    requires Linux kernel version 4.16.0 or higher.
  * Implemented decoding of KVM_SET_CPUID2 and KVM_GET_*_CPUID ioctl commands.
  * Enhanced decoding of corner cases of SO_LINGER, SO_PEERCRED,
    and PACKET_STATISTICS getsockopt options.
  * Wired up io_pgetevents and rseq syscalls on hppa, microblaze, mips, powerpc,
    and s390.
  * Updated lists of AUDIT_*, BPF_*, IFA_*, IFLA_*, RTA_*, RTPROT_*, TCP_*,
    TRAP_*, and UDP_* constants.
  * Updated lists of ioctl commands from Linux 4.18.

* Bug fixes
  * Fixed decoding of Q_XGETQSTAT on non-native personalities.
  * Fixed race condition in aio test.
  * Fixed build with Bionic libc.
  * Fixed build with glibc-2.28.
  * Fixed build in exotic systemd-nspawn based environments.
  * Fixed build on s390 with kernel headers that do not contain Linux commit
    v3.10-rc1~201^2~11.

Noteworthy changes in release 4.23 (2018-06-14)
===============================================

* Changes in behaviour
  * On x32 personality, 64-bit syscalls (such as readv) are now shown with "#64"
    suffix instead of "64:" prefix.  Unlike the old names, these new names
    can be used in syscall qualification expressions.
  * Changed error number output format: error numbers are consistently
    printed as "-1 ECONST (Error description)"
    for known errors and as "-1 (errno 123)" for unknown errors,
    regardless of -e raw qualification settings.  One can specify
    -X raw for displaying raw error numbers unconditionally.
  * Unfetchable addresses inside arrays are now printed as comments.
  * Obsolete IA-32 mode syscall names are no longer printed on ia64.

* Improvements
  * Implemented libdw backend for -k option, configured at build time
    using --with-libdw option.
    Whether -k option is compiled is now configured at build time
    using --enable-stacktrace option.
  * Added -X option for configuring xlat output formatting (addresses
    Debian bug #692915).
  * Added support for personality designation ("64", "32", or "x32") to syscall
    qualifications in -e trace expressions.
  * Implemented injection of syscalls with no side effects as an alternative
    to injection of an invalid syscall (-e inject=SET:syscall= expression).
  * Improved support for reproducible builds (addresses Debian bug #896016).
  * Implemented decoding of BPF_PROG_QUERY and BPF_RAW_TRACEPOINT_OPEN bpf
    syscall commands.
  * Implemented decoding of INOTIFY_IOC_SETNEXTWD and PERF_EVENT_IOC_* ioctl
    commands.
  * Implemented decoding of PR_GET_SPECULATION_CTRL and PR_SET_SPECULATION_CTRL
    prctl syscall options.
  * Enhanced decoding of bpf, getsockopt, setsockopt, and socket syscalls.
  * Enhanced decoding of NETLINK_KOBJECT_UEVENT and NETLINK_ROUTE protocols.
  * Enhanced decoding of *_DIAG_MEMINFO netlink attributes.
  * Enhanced decoding of BTRFS_*, FS_IOC_*, SIOCGIFHWADDR, and SIOCSIFHWADDR
    ioctl commands.
  * Enhanced decoding of AF_BLUETOOTH socket addresses.
  * Implemented decoding of io_pgetevent syscall.
  * Wired up rseq syscall.
  * Updated lists of ADJ_*, BPF_*, BPF_F_*, BPF_PROG_TYPE_*, ETH_P_*, FPE_*,
    IFF_*, IPPROTO_*, MAP_*, MS_*, MSG_*, NETLINK_*, PACKET_*, PROT_*, SCTP_*,
    SECCOMP_FILTER_FLAG_*, SEGV_*, SEM_*, SHM_*, SW_*, V4L2_CID_*,
    V4L2_CTRL_CLASS_*, and V4L2_PIX_FMT_* constants.
  * Updated lists of ioctl commands from Linux 4.17.

* Bug fixes
  * Fixed decoding of msgtyp argument of msgrcv syscall.
  * Fixed fallback definitions for F_*, MCL_*, MSG_ZEROCOPY, SI_*,
    and SOL_SOCKET constants.
  * Fixed -e trace=%pure expression on mips.

Noteworthy changes in release 4.22 (2018-04-05)
===============================================

* Changes in infrastructure
  * The mailing list was moved to strace-devel@lists.strace.io.
  * SourceForge git repository
    (https://sourceforge.net/p/strace/code/ci/master/tree/) is no longer
    maintained.  Please use GitLab (https://gitlab.com/strace/strace/)
    or GitHub (https://github.com/strace/strace/) repository instead.

* Changes in behaviour
  * When printing string data, '8' and '9' following an octal escape sequence
    no longer lead to unabbreviated octal escape sequence output, as they used
    to do.
  * Angle brackets are now printed as octal number escape sequences
    in the output of paths associated with file descriptors.
  * Data dump for write syscalls (-e write) is performed regardless
    of successfulness of these syscall (addresses Debian bug #436284).
  * -r and -t options are now affect output independently.  Previously,
    -r option led to ignoring of the -t option (addresses Debian bug #466195).

* Improvements
  * Implemented delay injection (-e inject=SET:delay_enter= and
    -e inject=SET:delay_exit= options).
  * Added -A option for opening output files in append mode
    (addresses Debian bug #528488).
  * IPv6 addresses shown in socket information in -yy mode are now printed
    in brackets.
  * Enhanced decoding of bpf, prctl and ptrace syscalls.
  * Enhanced decoding of BTRFS_IOC_INO_PATHS, BTRFS_IOC_LOGICAL_INO, and PTP_*
    ioctl commands.
  * Enhanced NETLINK_ROUTE protocol decoding.
  * Updated lists of signal codes.
  * Updated lists of BPF_*, BTN_*, ETH_P_*, INET_DIAG_BC_*, KEY_*, POLL*, RWF_*,
    SCHED_FLAG_*, SCTP_* and error constants.
  * Implemented block/character device number printing in -yy mode.
  * Known pixel/SDR format names are printed as comments for pixelformat fields
    in v4l2 structures.
  * Enhanced decoding of kern_features syscall.
  * Enhanced NETLINK_NETFILTER netlink protocol decoder.
  * Optimized handling of large number of tracees.
  * Improved wall clock time measurement in syscall count statistics
    (-c -w option).
  * Extended the range of allowed values in -e inject=...:retval= expression.
  * Added i18n support.
  * Updated lists of ioctl commands from Linux 4.16.
  * Enhanced manual page.

* Bug fixes
  * Fixed build on m68k.
  * Fixed v4l2 pixelformat decoding on big-endian architectures.
  * Fixed -O option.

Noteworthy changes in release 4.21 (2018-02-13)
===============================================

* Changes in behaviour
  * Warning is now issued when -F option is used.
  * Warning is now issued when a tracee with unsupported personality
    is attached.
  * Unknown syscall numbers are now printed in hexadecimal form.

* Improvements
  * Implemented decoding of netlink descriptor attributes as file descriptors.
  * Implemented decoding of hugetlb page size selection flags.
  * Implemented decoding of BPF_PROG_TEST_RUN, BPF_PROG_GET_NEXT_ID,
    BPF_MAP_GET_NEXT_ID, BPF_PROG_GET_FD_BY_ID, BPF_MAP_GET_FD_BY_ID,
    and BPF_OBJ_GET_INFO_BY_FD commands of bpf syscall.
  * Enhanced decoding of get_thread_area, memfd_create, modify_ldt,
    perf_event_open, reboot, s390_guarded_storage, s390_pcio_mmio_read,
    s390_pci_mmio_write, s390_runtime_instr, s390_sthyi, set_thread_area,
    and shmget syscalls.
  * Implemented decoding of KVM_* and DM_LIST_DEVICES ioctl commands.
  * Implemented decoding of riscv_flush_icache syscall.
  * Enhanced decoding of getsockopt and setsockopt syscalls for SOL_NETLINK
    level.
  * Enhanced decoding of BPF_MAP_CREATE command of bpf syscall.
  * Print values returned by mq_open syscall and first arguments
    of mq_getsetattr, mq_notify, mq_timedreceive, and mq_timedsend syscalls
    as file descriptors.
  * Added decoding of get_tls syscall on arm.
  * Added -e trace=%pure option for tracing system calls with no arguments that
    never fail.
  * Updated lists of IPV6_*, MAP_*, MEMBARRIER_CMD_*, MSG_*, NT_*, PKEY_*,
    SHM_*, and TCP_* constants.
  * Added manual page for the strace-log-merge command.
  * Updated lists of ioctl commands from Linux 4.15.
  * Implemented biarch support for s390x.
  * Implemented an optional support for symbol demangling in strace -k output
    (activated by --with-libiberty configure option).
  * Information about availability of demangling and reliable personality
    decoding (on architectures with multiple personalities) is now available
    in strace -V output.
  * Added decoding of pkey_alloc, pkey_free, and pkey_mprotect syscalls on
    powerpc and powerpc64.
  * Enhanced manual page.

* Bug fixes
  * Fixed multi-personality support in cross builds.
  * Added mq_getsetattr, mq_notify, mq_open, mq_timedreceive, and mq_timedsend
    syscalls to %desc tracing set.
  * Fixed path tracing support for mmap syscalls with indirect arguments and
    for old select syscall.
  * Fixed decoding of arm-specific (__ARM_NR_*) syscalls.
  * Fixed open mode flags decoding.
  * Fixed corner cases in handling of strace -ff -ttt logs by strace-log-merge.
  * Error counts that exceed one billion are now printed correctly in call
    summary output.
  * Fixed call summary header for x32 personality.
  * Changes of tracee personalities are reported more reliably.
  * Fixed the case when strace attaches to a tracee being inside exec and its
    first syscall stop is syscall-exit-stop instead of syscall-enter-stop,
    which messed up all the syscall state tracking.
  * Fixed printing of higher 32 bits of the return value for x32 personality.

* Portability
  * A C compiler that supports "for" loop initial declarations is now required.
  * Inability to configure multiple personality support on architectures where
    multiple personalities are supported leads to configuration failure during
    build now.  Use --enable-mpers=check to revert to the old behaviour.
  * Build-time requirement for the mpers support has been lowered from gawk 4
    to gawk 3.
  * Removed incomplete and non-functional support for the CRIS architecture.
  * Removed incomplete and unused support for IA-32 mode on the IA-64
    architecture.

Noteworthy changes in release 4.20 (2017-11-13)
===============================================

* Improvements
  * Implemented decoding of NETLINK_NETFILTER netlink message types and flags.
  * Implemented decoding of SECCOMP_GET_ACTION_AVAIL operation of seccomp
    syscall.
  * Updated lists of ARPHRD_*, BPF_*, ETH_P_*, LOOP_*, MADV_*,
    MEMBARRIER_CMD_*, MFD_*, SECCOMP_*, SO_*, SOL_*, TCP_*, and UFFD_FEATURE_*
    constants.
  * Added decoding of statx syscall on hppa.
  * Updated lists of ioctl commands from Linux 4.14.

* Bug fixes
  * Fixed powerpc personality support on powerpc64.

Noteworthy changes in release 4.19 (2017-09-05)
===============================================

* Changes in behaviour
  * Changed formatting of personality names on tile architecture in order
    to make it in line with other multi-personality architectures.
  * Changed field output order in struct v4l2_requestbuffers to improve in/out
    field formatting.
  * Changed handling of multiple signal= specifications in an injection
    expression: multiple specification now leads to error instead of implicit
    usage the last specification.

* Improvements
  * Enhanced decoding of optlen argument of getsockopt syscall.
  * Enhanced decoding of SO_LINGER option of getsockopt and setsockopt syscalls.
  * Enhanced decoding of SO_PEERCRED option of getsockopt syscall.
  * Enhanced decoding of IP_ADD_MEMBERSHIP, IP_DROP_MEMBERSHIP,
    IPV6_ADD_MEMBERSHIP, IPV6_DROP_MEMBERSHIP, IPV6_JOIN_ANYCAST,
    IPV6_LEAVE_ANYCAST, MCAST_JOIN_GROUP, and MCAST_LEAVE_GROUP options
    of setsockopt syscall.
  * Enhanced decoding of KEYCTL_DH_COMPUTE operation of keyctl syscall
    (KDF parameters decoding).
  * Implemented decoding of KEYCTL_RESTRICT_KEYRING operation of keyctl syscall.
  * Enhanced decoding of UFFDIO_API ioctl command.
  * Enhanced decoding of BPF_PROG_LOAD, BPF_MAP_CREATE, BPF_MAP_LOOKUP_ELEM,
    and BPF_MAP_GET_NEXT_KEY commands of bpf syscall.
  * Implemented decoding of linux socket filter programs specified
    for SO_ATTACH_FILTER and SO_ATTACH_REUSEPORT_CBPF socket options.
  * Implemented decoding of inet_diag_req_v2, inet_diag_req_compat,
    packet_diag_msg, and smc_diag_msg netlink attributes of NETLINK_SOCK_DIAG.
  * Implemented NETLINK_SELINUX protocol specific decoding.
  * Implemented decoding of netlink message ack flags.
  * Implemented decoding of nlmsgerr netlink attributes.
  * Implemented basic protocol specific decoding of NETLINK_CRYPTO.
  * Implemented decoding of crypto_user_alg netlink attributes
    of NETLINK_CRYPTO.
  * Implemented basic protocol specific decoding of addr, addrlabel, dcb, link,
    mdb, neigh, neightbl, netconf, nsid, route, rule, tc, and tca messages
    of NETLINK_ROUTE.
  * Implemented decoding of NETLINK_KOBJECT_UEVENT messages.
  * Improved handling of unexpected tracees (the ones that cloned with
    CLONE_PARENT/CLONE_PTRACE or called PTRACE_TRACEME on themselves): they
    are now PTRACE_DETACH'ed instead of PTRACE_CONT'ed.
  * Updated lists of BPF_*, KEY_*, RWF_*, SCM_*, SO_*, and *_MAGIC constants.
  * Added decoding of arch_prctl syscall on x86.
  * Added decoding of seccomp, bpf, userfaultfd, membarrier, mlock2,
    copy_file_range, preadv2, pwritev2, and statx on alpha.
  * Added decoding of statx syscall on microblaze.
  * Added decoding of s390_guarded_storage syscall on s390.
  * Updated lists of ioctl commands from Linux 4.13.
  * Enhanced manual page.

* Bug fixes
  * Fixed printing of group_req structure on non-native personalities.
  * Fixed output formatting of blkpg_ioctl_arg, dm_name_list, and iocb
    structures.
  * Fixed formatting of nul-terminated strings which have kernel-imposed size
    limit.
  * Fixed printing of paths that hit PATM_MAX limit in order to match kernel's
    behaviour.
  * Fixed build warnings on Android mips64.
  * Fixed unused function "is_negated_errno" build warning when built
    with clang.
  * Fixed syscall number and arguments retrieval behaviour on sparc64 and
    mips o32 after prctl(PR_SET_DUMPABLE, 0) makes PTRACE_PEEKTEXT impossible
    to use if Linux kernel has commit v4.10-rc1~114^2~2.
  * Fixed path tracing for execveat, symlink, symlinkat, inotify_add_watch,
    and inotify_init syscalls.
  * Fixed personality switch printing on sparc64 and risc-v.

Noteworthy changes in release 4.18 (2017-07-05)
===============================================

* Improvements
  * Implemented decoding of SCM_TIMESTAMP* control messages.
  * Implemented decoding of netlink NLMSG_DONE messages.
  * Implemented decoding of netlink generic nlmsg_type and nlmsg_flags.
  * Implemented decoding of NETLINK_AUDIT, NETLINK_NETFILTER, NETLINK_ROUTE,
    NETLINK_SELINUX, NETLINK_SOCK_DIAG, and NETLINK_XFRM message types.
  * Implemented decoding of NETLINK_GENERIC protocol families.
  * Implemented basic protocol specific decoding of AF_INET, AF_INET6,
    AF_NETLINK, AF_PACKET, AF_SMC, and AF_UNIX messages of NETLINK_SOCK_DIAG.
  * Implemented basic decoding of netlink attributes.
  * Implemented basic protocol specific decoding of AF_INET, AF_NETLINK,
    AF_PACKET, AF_SMC, and AF_UNIX netlink attributes of NETLINK_SOCK_DIAG.
  * Implemented decoding of inet_diag_msg, netlink_diag_msg, and unix_diag_msg
    netlink attributes of NETLINK_SOCK_DIAG.
  * Updated lists of ARPHRD_*, KEYCTL_*, NDIAG_SHOW_*, RTM_*, SCM_*, SCTP_*,
    SO_*, V4L2_*, and prctl ARCH_* constants.
  * Updated lists of ioctl commands from Linux 4.12.

* Bug fixes
  * In interactive mode (-I2), those signals that were blocked at startup
    will remain blocked for the whole period of strace execution.
  * strace no longer resets SIGCHLD handler in tracees to the default action.
  * When traced command is terminated by a blocked signal, strace unblocks
    that signal to ensure its own termination with the same signal.
  * Fixed corner cases in decoding of old sigaction syscall.
  * Fixed build with old kernel headers on mips.
  * Fixed build on aarch64 and tile with glibc >= 2.26.
  * Fixed build on arc and nios2.

Noteworthy changes in release 4.17 (2017-05-24)
===============================================

* Changes in command line syntax
  * Syscall classes specified in -e trace= option now have % prefix (like
    -e trace=%process).  Old style class names without leading % are still
    supported, but considered deprecated now.

* Improvements
  * Optimized syscall filtering.
  * Improved representation of timestamps.
  * Enhanced decoding of sched_setattr syscall.
  * Added -e trace=%stat option for tracing variants of stat syscall.
  * Added -e trace=%lstat option for tracing variants of lstat syscall.
  * Added -e trace=%fstat option for tracing variants of fstat and fstatat
    syscalls.
  * Added -e trace=%%stat option for tracing syscalls used for querying file
    status information (stat, lstat, fstat, fstatat, statx, and their
    variations).
  * Added -e trace=%statfs option for tracing statfs, statfs64 and statvfs
    syscalls.
  * Added -e trace=%fstatfs option for tracing fstatfs, fstatfs64 and fstatvfs
    syscalls.
  * Added -e trace=%%statfs option for tracing syscalls used for querying file
    system statistics information (statfs-like, fstatfs-like and ustat).
  * Added -e trace=/regex option for filtering syscalls using regular
    expressions.
  * Added support for prepending of question mark before syscall qualification
    in -e trace expressions in order to suppress error in case no syscalls
    matched the provided qualification.
  * Implemented decoding of signal mask in rt_sigreturn syscall on alpha, arc,
    arm, avr32, bfin, cris, hppa, m68k, metag, microblaze, mips, nios2, or1k,
    powerpc, powerpc64, riscv, sh, sh64, sparc, sparc64, tile, x86, and xtensa
    architectures.
  * Implemented decoding of statx syscall.
  * Implemented decoding of NS_* ioctl commands.
  * Implemented decoding of the remaining V4L2_BUF_TYPE_* types.
  * Implemented decoding of VIDIOC_[SG]_TUNER ioctl commands.
  * Implemented decoding of NLMSG_ERROR netlink messages.
  * Improved decoding of BPF_PROG_ATTACH command of bpf syscall.
  * Improved decoding of misplaced parts in DM_* ioctl commands.
  * Updated lists of ioctl commands from Linux 4.11.

* Bug fixes
  * Fixed decoding of flags argument of preadv2 and pwritev2 syscalls on x32.
  * Fixed the number of arguments and tracing flags of alpha specific syscalls.
  * Fixed decoding of old sigsuspend syscall on alpha, cris, mips, powerpc,
    powerpc64, sh, sh64, sparc, and sparc64.
  * Fixed decoding of sgetmask and ssetmask syscalls on 64-bit architectures.
  * Fixed decoding of netlink messages received within struct msghdr.
  * Worked around a bug in miscompiled aarch64 kernels leading to the 3rd
    argument of sched_getattr syscall being not quite 32-bit.
  * Fixed corner cases of printing inaccessible times argument of utimes
    and futimesat syscalls.

Noteworthy changes in release 4.16 (2017-02-14)
===============================================

* Improvements
  * Implemented syscall return value injection (-e inject=SET:retval= option).
  * Implemented signal injection (-e inject=SET:signal= option).
  * Implemented decoding of SUID_DUMP_* constants in PR_[GS]ET_DUMPABLE.
  * Implemented decoding of all SG_* ioctl commands.
  * Implemented decoding of ustat syscall.
  * Implemented decoding of BPF_OBJ_PIN, BPF_OBJ_GET, BPF_PROG_ATTACH,
    and BPF_PROG_DETACH commands of bpf syscall.
  * Enhanced decoding of sg_io_hdr and sg_io_v4 structures.
  * Enhanced decoding of get_robust_list, getrandom, io_submit, set_robust_list
    syscalls.
  * Enhanced decoding of entities of kernel long type on x32 and mips n32 ABIs.
  * Updated lists of IP_*, IPV6_*, and LOOP_* constants.
  * Updated lists of ioctl commands from Linux 4.10.
  * Added decoding of recently added syscalls on avr32, microblaze, ppc,
    and ppc64.

* Bug fixes
  * Fixed pathmatch of oldselect syscall on 64-bit architectures.
  * Fixed decoding of mmap2 syscall on s390 when arguments are not available.
  * Fixed decoding of kexec_file_load, mprotect, pkey_mprotect, prctl, preadv*,
    and pwritev* syscalls on x32.
  * Fixed printing of string arguments of getxattr and setxattr syscalls
    when -s option is used to limit the printed string size.
  * Fixed decoding of ifconf, ifreq, and loop_info structures on non-native
    personalities.
  * Fixed decoding of SG_* and LOOP_* ioctl commands.
  * Fixed build on mips with musl libc.
  * Fixed cross-building of ioctlsort.
  * Applied minor formatting fixes to the manual page.

Noteworthy changes in release 4.15 (2016-12-14)
===============================================

* Changes in behavior
  * Time stamps are now printed according to ISO 8601.
  * Changed output format of val3 parameter of futex FUTEX_WAKE_OP operation.
  * The last argument of mincore, sched_getaffinity, and sched_setaffinity
    syscalls is now formatted as an array.

* Improvements
  * Implemented syscall fault injection (-e fault=... option).
  * Implemented decoding of DM_* ioctl commands.
  * Implemented decoding of attr parameter of perf_event_open syscall.
  * Implemented decoding of pkey_alloc, pkey_free, and pkey_mprotect syscalls.
  * Implemented dumping of mq_timedsend and mq_timedreceive syscalls.
  * Implemented decoding of PR_SET_FP_MODE and PR_GET_FP_MODE operations
    of prctl syscall.
  * Implemented PTRACE_GETREGS API support on m68k.
  * Updated lists of ARCH_*, BPF_*, BTRFS_*, FALLOC_*, MS_*, *_MAGIC,
    and V4L2_* constants.
  * Updated lists of ioctl commands from Linux 4.9.
  * Added decoding of recently added syscalls on arc, x32, and xtensa.
  * Enhanced manual page.

* Bug fixes
  * Fixed corner cases in decoding of exit, exit_group, futimesat, getgroups,
    getresuid, init_module, inotify_init1, kcmp, kexec_load, lookup_dcookie,
    mq_getsetattr, mq_notify, mq_open, mq_timedreceive, mq_timedsend,
    name_to_handle_at, prctl, process_vm_readv, process_vm_writev, setfsuid,
    setgroups, setns, unshare, and utimes syscalls.
  * Fixed handling of verbose flag in printing of controls array
    of struct v4l2_ext_controls.
  * Fixed omission of field names in the output of capability, sigaction,
    sigevent, statfs, timespec, timeval, and utimbuf structures.
  * Fixed printing of unknown syscalls in siginfo structure.
  * Fixed decoding of ioctl constants on m68k.
  * Fixed cris architecture support.
  * Fixed cross build when host compiler does not support the same
    set of warning flags as the cross compiler.
  * Fixed build on SLE10 and SLE11.

Noteworthy changes in release 4.14 (2016-10-04)
===============================================

* Changes in behavior
  * When using -p option without a command and no processes has been attached,
    strace exits with exit status 1.

* Improvements
  * Added printing of the mode argument of open and openat syscalls
    when O_TMPFILE flag is set.  (Addresses Fedora bug #1377846).
  * Enhanced -e abbrev=set, -e raw=set, and -e verbose=set.
  * Enhanced decoding of futex, keyctl, quotactl, timerfd_settime,
    and aio family syscalls.
  * Implemented fetching of the 7th subcall argument on mips o32.
  * Updated lists of BPF_*, ETH_P_*, KEXEC_ARCH_*, SCTP_*, TCP_*, and *_MAGIC
    constants.
  * Updated lists of ioctl commands from Linux 4.8.
  * Added decoding of new syscalls on sh and sh64.
  * Added RISC-V architecture support.

* Bug fixes
  * Marked io_setup and io_destroy as memory mapping related syscalls.
  * Fixed leakage of placeholder descriptors to tracees.
  * Fixed printing of mode_t, umode_t, and umask types.
  * Fixed decoding of iovec arrays without a limit on total data size.
  * Fixed decoding of fadvise64, fallocate, futex, keyctl, quotactl, readahead,
    and ipc family syscalls.
  * Fixed decoding of invalid syscalls mapped to indirect subcalls.
  * Fixed decoding of struct btrfs_ioctl_vol_args_v2 on non-native
    personalities.
  * Fixed decoding of PTRACE_DETACH on sparc and sparc64.
  * Fixed decoding of struct stat64 on sparc64.
  * Fixed decoding of uid and gid-related syscalls on sparc64.
  * Fixed decoding of the forth argument of semctl syscall on sparc64.
  * Fixed values of tty ioctl constants on sparc64.
  * Fixed sparc personality support on sparc64.

Noteworthy changes in release 4.13 (2016-07-26)
===============================================

* Improvements
  * Implemented a general netlink socket parser.
  * Enhanced decoding of socket addresses.
  * Enhanced decoding of cmsghdr, msghdr, and mmsghdr structures.
  * Enhanced decoding of accept, accept4, bind, getpeername, getsockname,
    ipc, recvfrom, recvmsg, recvmmsg, sendto, sendmmsg, and socketcall syscalls.
  * Updated lists of AF_*, BPF_MAP_TYPE_*, KEY_*, KEYCTL_*, RWF_*, SS_*,
    and *_MAGIC constants.
  * Updated lists of ioctl commands from Linux 4.7.

* Bug fixes
  * Fixed decoding of pid_t argument of prlimit64 syscall.
  * Fixed sign extension issues in the parser of struct rusage.
  * Fixed race condition in decoding of timeout argument of recvmmsg and
    rt_sigtimedwait syscalls.
  * Fixed build with fresh linux kernel headers.

Noteworthy changes in release 4.12 (2016-05-31)
===============================================

* Improvements
  * Implemented simultaneous use of -p option and tracing of a command.
    (addresses Debian bug #549942).
  * Implemented caching of netlink conversations to reduce amount of time
    spent in decoding socket details in -yy mode.
  * Implemented -yy mode decoding of protocol:portid pairs associated with
    netlink socket descriptors.
  * Implemented decoding of copy_file_range, preadv2, and pwritev2 syscalls.
  * Implemented dumping of preadv, preadv2, pwritev, pwritev2, and vmsplice
    syscalls.
  * Implemented decoding of BTRFS_* and UFFDIO_* ioctl commands.
  * Enhanced decoding of BLK*, EVIOC*, RTC_*, and VIDIOC_* ioctl commands.
  * Enhanced decoding of fstatfs, fstatfs64, get_mempolicy, getdents,
    getdents64, getgroups, getpriority, kill, mbind, migrate_pages, mknod,
    mknodat, personality, poll, ppoll, quotactl, rt_sigpending,
    rt_sigqueueinfo, rt_sigtimedwait, rt_tgsigqueueinfo, sched_getaffinity,
    sched_setaffinity, seccomp, set_mempolicy, setgroups, setpriority, statfs,
    statfs64, tgkill, waitid, and xattr family syscalls.
  * Enhanced decoding of getxpid, getxuid, and getxgid syscalls on alpha.
  * Enhanced decoding of pipe syscall on alpha, ia64, mips, sh, and sparc.
  * Added decoding of bind, listen, and setsockopt direct syscalls on sparc.
  * Added decoding of osf_statfs64 and osf_fstatfs64 syscalls on alpha.
  * Added decoding of fadvise64 and fadvise64_64 on s390.
  * Updated lists of AF_*, BPF_MAP_TYPE_*, CLONE_*, EPOLL*, IPV6_*, MADV_*,
    MSG_*, PTRACE_*, SEGV_*, SO_*, SOL_*, *_MAGIC, and quotactl constants.
  * Updated lists of ioctl commands from Linux 4.6.

* Bug fixes
  * Fixed build on arc, metag, nios2, or1k, and tile architectures.
  * Fixed decoding of 32-bit times syscall return value on 64-bit architectures.
  * Fixed decoding of mlock2 syscall on sparc.
  * Fixed decoding of osf_shmat syscall on alpha.
  * Fixed decoding of syscalls unknown to the kernel on s390/s390x.
    (addresses Debian bug #485979 and Fedora bug #1298294).
  * Fixed decoding of preadv syscall in case of short read.
  * Fixed decoding and dumping of readv syscall in case of short read.
  * Fixed dumping of recvmsg and recvmmsg syscalls in case of short read.
  * Fixed decoding of mincore syscall's last argument.
  * Fixed remaining errors in mapping between syscall numbers and numbers
    of syscall arguments.
  * Applied various fixes to strace-graph script.

Noteworthy changes in release 4.11 (2015-12-21)
===============================================

* Changes in behavior
  * Some syscalls have different names depending on architecture and
    personality.  In these cases, syscall filtering and printing now
    consistently uses the names that match corresponding __NR_* kernel
    macros of the tracee's architecture and personality.
  * Added strace prefix to all diagnostic messages.

* Improvements
  * Enhanced and extended test suite.
  * Implemented reliable tracing of processes whose personality differs
    from the personality of strace, fixed decoding of 32-bit personality
    syscalls on 64-bit architectures.
  * When some data referenced by syscall arguments is irrelevant or cannot
    be read from tracee's memory, strace now prints its address consistently.
  * When a syscall is restarted using restart_syscall mechanism, strace now
    shows the syscall name on architectures that expose this information.
  * Print values returned by epoll_create1, eventfd, eventfd2, fanotify_init,
    inotify_init1, perf_event_open, pipe, pipe2, signalfd, signalfd4, socket,
    socketpair, timerfd, and timerfd_create syscalls, as well as F_DUPFD and
    F_DUPFD_CLOEXEC fcntl commands, as file descriptors.
  * Optimized decoding of indirect socket syscalls.
  * Implemented decoding of nanoseconds along with seconds in stat family
    syscalls (addresses Fedora bug #1251176).
  * Implemented decoding of struct statfs.f_flags in statfs syscall.
  * Implemented decoding of siginfo_t.si_syscall and siginfo_t.si_arch
    in SIGSYS signal.
  * Implemented decoding of indirect syscall on mips o32.
  * Implemented decoding of IPPROTO_IP control messages.
  * Implemented decoding of setsockopt syscall multicast arguments.
  * Enhanced decoding of struct sigevent.
  * Enhanced decoding of block, loop, mtd, ptp, rtc, SG_IO, socket, tty,
    and v4l2 ioctl syscall arguments.
  * Enhanced decoding of epoll_create, fcntl, fcntl64, futex, getdents,
    getdents64, getsockopt, io_*, mount, msgctl, prctl, quotactl, recvfrom,
    sendfile, setsockopt, and shmctl syscalls.
  * Implemented decoding of bpf, execveat, ioperm, iopl, kcmp, kexec_file_load,
    lookup_dcookie, membarrier, memfd_create, mlock2, name_to_handle_at,
    open_by_handle_at, sched_getattr, sched_setattr, and userfaultfd syscalls.
  * Updated lists of AF_*, EPOLL_*, FALLOC_FL_*, F_*, INPUT_PROP_*, IPPROTO_*,
    IPV6_*, IP_*, KEY_*, LOCK_*, MNT_*, MS_*, PACKET_*, PERF_FLAG_*, PF_*,
    PR_*, PTRACE_O_*, RENAME_*, SCTP_*, SECBIT_*, SO_*, TCP_*, and siginfo_t
    constants.
  * Added Nios II architecture support.
  * Added new syscall entries to match Linux 4.4.

* Bug fixes
  * Fixed potential short read of strings from tracee's memory.
  * Fixed -qq option in conjunction with -o option.
  * Fixed filtering of <unavailable> syscalls.
  * Fixed decoding of ioctl syscall command on aarch64 and 32-bit architectures
    with 64-bit aligned structures.
  * Fixed decoding of eventfd2, epoll_create1, signalfd4, and sync_file_range2
    syscall flags arguments.
  * Fixed decoding of 4th argument of clock_nanosleep syscall.
  * Fixed decoding of getpagesize syscall on m68k.
  * Fixed decoding of getrandom and seccomp syscalls on aarch64.
  * Fixed decoding of timezone argument of gettimeofday and settimeofday
  * syscalls.
  * Fixed decoding of offset argument of mmap2 syscall on arm, sparc,
    and sparc64.
  * Fixed decoding of pipe syscall on alpha and mips.
  * Fixed decoding of pipe2 syscall on ia64, sh, sparc, and sparc64.
  * Fixed decoding of signal mask argument of pselect6 syscall on x32.
  * Fixed decoding of signal mask of rt_sigreturn syscall on aarch64, m68k,
    and x32.
  * Fixed decoding of 4th argument of semctl indirect syscall.
  * Fixed decoding of sa_restorer and sa_mask of sigaction syscall on m68k.
  * Fixed decoding of statfs64 and fstatfs64 syscalls on arm eabi.
  * Fixed decoding of struct dirent on x32.
  * Fixed decoding of times syscall return value on mips n32 and x32.
  * Fixed decoding of path argument of umount2 syscall
    (addresses Debian bug #785050).
  * Worked around a kernel bug in tracing privileged executables.
  * Fixed various errors in mapping between syscall numbers and associated
    information like the number of syscall arguments, the name of syscall,
    and syscall decoder.

Noteworthy changes in release 4.10 (2015-03-06)
===============================================

* Improvements
  * Added -yy option to print protocol and address information associated with
    socket descriptors.
  * Extended "-e read=set" and "-e write=set" options to cover sendmsg,
    recvmsg, sendmmsg, and recvmmsg syscalls.
  * Implemented full 32-bit decoding of ioctl commands
    (addresses Debian bug #692913 and Fedora bug #902788).
  * Implemented PTRACE_GETREGS API support on ia64.
  * Implemented PTRACE_GETREGS API support on mips.
  * Implemented PTRACE_GETREGSET API support on s390/s390x.
  * Implemented decoding of getrandom and seccomp syscalls.
  * Implemented full decoding of 64-bit capability sets.
  * Implemented decoding of all prctl commands.
  * Implemented decoding of parametrized ioctl commands.
  * Implemented decoding of evdev ioctl commands.
  * Implemented decoding of v4l ioctl commands.
  * Implemented decoding of SG_IO v4 ioctl commands.
  * Implemented decoding of FIFREEZE/FITHAW/FITRIM ioctl commands.
  * Implemented decoding of FALLOC_FL_* fallocate flags.
  * Implemented decoding of rt_sigreturn signal mask on aarch64,
    x32, and x86_64.
  * Enhanced socket decoder to support bluetooth sockets.
  * Enhanced decoding of unlisted ioctl commands.
  * Enhanced decoding of getsockopt and setsockopt syscall.
  * Enhanced decoding of sysinfo syscall.
  * Enhanced decoding of struct cmsghdr.
  * Enhanced decoding of wait status.
  * Enhanced aio support on non-x86 architectures by using external libaio.h.
  * Added O_TMPFILE to the list of recognized open mode flags.
  * Updated the list of filesystem type constants that is used in decoding
    statfs family syscalls.
  * Updated lists of CAP_*, PR_*, PTRACE_*, SCHED_*, SO_*, SOL_*, SWAP_FLAG_*,
    and TFD_* constants.
  * Updated lists of signal constants from Linux 3.19.
  * Updated lists of errno constants from Linux 3.19.
  * Updated lists of ioctl commands from Linux 3.9.
  * Added new syscall entries to match Linux 3.19.

* Bug fixes
  * Fixed various errors in mapping between syscall numbers and associated
    information like the number of syscall arguments, the name of syscall,
    and syscall decoder.
  * Fixed quoting issues in printing descriptors, filenames, network interface
    names, struct utsname members, device/volume names of BLK* ioctl commands.
  * Fixed uid_t/git_t decoding.
  * Fixed potential out-of-bounds read issues in getdents/getdents64 decoders.
  * Fixed potential open flags truncation on some architectures.
  * Fixed decoding of struct ifreq.ifr_name.
  * Fixed decoding of SIOCSIFNAME ioctl command.
  * Fixed decoding of RENAME_* renameat2 flags.
  * Fixed decoding of UTIME_NOW/UTIME_OMIT timeval structures.
  * Fixed decoding of indirect ipc subcalls on some architectures.
  * Fixed decoding of fanotify_mark syscall on 32-bit architectures.
  * Fixed decoding of 32-bit stat structures on 64-bit architectures.
  * Fixed decoding of 32-bit struct cmsghdr on 64-bit architectures.
  * Fixed decoding of 32-bit preadv/pwritev offset on 64-bit architectures.
  * Fixed decoding of sigreturn/rt_sigreturn signal mask on ia64, ppc, ppc64,
    sparc, sparc64, mips, and s390.
  * Fixed instruction pointer output (-i option) on architectures that support
    several personalities.
  * Fixed behaviour of "-e read=set" and "-e write=set" when read and write
    sets intersect.
  * Fixed build on systems where struct sigaction has no sa_restorer member.
  * Fixed build with uclibc and musl libc.

* Portability
  * Linux kernel >= 2.5.46 is required.
    Older versions without a decent PTRACE_SETOPTIONS support will not work.
  * On mips, linux kernel >= 2.6.15 is required.
    Older versions without a decent PTRACE_GETREGS support will not work.
  * On s390 and s390x, linux kernel >= 2.6.27 is required.
    Older versions without a decent PTRACE_GETREGSET support will not work.

Noteworthy changes in release 4.9 (2014-08-15)
==============================================

* Changes in behavior
  * Disabled OABI support on ARM EABI systems by default,
    added --enable-arm-oabi option to enable it at configure time.

* Improvements
  * Added experimental -k option to print stack trace after each traced syscall.
  * Added -w option to produce stats on syscall latency.
    (addresses Debian bug #457497).
  * Added ARC architecture support.
  * Added PTRACE_GETREGS API support on PowerPC.
  * Enhanced Bionic libc and musl libc support.
  * Enhanced tracing of x86 personality processes on x86_64 and x32.
  * Enhanced tracing of ARM personality processes on AArch64.
  * Enhanced 32/64bit personality detection on PowerPC.
  * Implemented decoding of add_key, ioprio_get, ioprio_set, kexec_load, keyctl,
    renameat2, and request_key syscalls.
  * Robustified decoding of select, pselect, and io_submit syscalls.
  * Enhanced decoding of delete_module, fanotify_init, fanotify_mark, fcntl,
    setdomainname, sethostname, setns, and sync_file_range syscalls.
  * Enhanced decoding of signal bitmasks.
  * Enhanced decoding of file descriptors.
  * Enhanced siginfo_t decoding.
  * Enhanced PF_NETLINK decoding.
  * Updated CLOCK_* constants
    (addresses Fedora bug #1088455).
  * Added new syscall entries to match Linux 3.16.

* Bug fixes
  * Added shmat and shmdt to the set of memory mapping related syscalls.
  * Fixed detaching from stopped processes.
  * Fixed fanotify_mark decoding on 32bit architectures.
  * Fixed offset decoding in preadv and pwritev syscalls.
  * Fixed select decoding for glibc in _FORTIFY_SOURCE mode.
  * Fixed decoding of epoll_ctl syscall with EPOLL_CTL_DEL argument.
  * Fixed build when <sys/ptrace.h> and <linux/ptrace.h> conflict
    (addresses Fedora bug #993384).
  * Miscellaneous corrections in the manual page.
    (Addresses Debian bug #725987).

Noteworthy changes in release 4.8 (2013-06-03)
==============================================

* Changes in behavior
  * In case of normal strace termination, when the trace output is
    redirected to a pipe, strace now closes it and waits for the pipe
    process termination before exit.

* Improvements
  * Implemented tracing using PTRACE_SEIZE API (when available).
  * Implemented more reliable PTRACE_GETREGSET-based process personality
    detection on x86-64 and x32 (when available).
  * Added -e trace=memory option for tracing memory mapping related syscalls.
  * Documented -b option.
  * Allowed exit status messages to be suppressed by giving -q option twice.
  * Added AArch64 architecture support
    (addresses Debian bug #693074 and Fedora bug #969858).
  * Added support for OpenRISC 1000, Meta, and Xtensa architectures.
  * Added tilegx personality support for Tile.
  * Enhanced support of NOMMU architectures.
  * Enhanced decoding of getdents, mmap, perf_event_open, ptrace, and
    quotactl syscalls.
  * Added new syscall entries to match Linux 3.9.
  * Regenerated the list of common ioctl names from Linux 3.9.
  * Updated the list of errno constants.
  * Updated lists of AF_*, MADV_*, MAP_*, MSG_*, MS_*, PF_*, PR_*,
    PTRACE_O_*, and TCP_* constants.
  * Implemented decoding of UBI ioctls.
  * Removed redundant "*32" ioctl names.

* Bug fixes
  * Fixed ERESTARTNOINTR leaking to userspace on ancient kernels
    (addresses Fedora bug #659382).
  * Fixed kernel release string parsing
    (addresses Debian bug #702309).
  * Fixed decoding of *xattr syscalls
    (addresses Fedora bug #885233).
  * Fixed handling of files with 64-bit inode numbers by 32-bit strace
    (addresses Fedora bug #912790).
  * Fixed tracing forks on SPARC.
  * Fixed decoding of fadvise64, fallocate, ftruncate64, io_submit, pread,
    preadv, pwrite, pwritev, readahead, sigaltstack, sync_file_range, sysctl,
    and truncate64 syscalls.
  * Fixed categories of multiple syscalls on most of supported architectures.
  * Fixed decoding of non-native 32-bit personality recv[m]msg syscalls.
  * Fixed decoding of multiple 32-bit personality syscalls on x32.
  * Fixed decoding of long long syscall arguments on ARM, MIPS/o32, PowerPC,
    S390x, and Tile architectures.
  * Fixed semtimedop decoding on S390x.
  * Fixed sram_alloc decoding on Blackfin.
  * Fixed build when process_vm_readv is a stab.
  * Fixed build with older versions of libaio.h.

Noteworthy changes in release 4.7 (2012-05-02)
==============================================

* Changes in behavior
  * strace no longer suspends waitpid until there is a child
    for waitpid'ing process to collect status from.
  * strace no longer detaches from a tracee which is supposed
    to be going to die.
  * strace now issues a new message: "+++ exited with EXITCODE +++"
    which shows exact moment strace got exit notification,
    analogous to existing "+++ killed by SIG +++" message.

* Improvements
  * Added x32 personality support (x86_64 architecture).
  * Added -y and -P options to print file descriptor paths and
    filter by those paths.
  * Added -I option to control strace interactivity.
  * Allowed -p option to take comma or whitespace-separated list of PIDs.
  * Added strace_log_merge script helper to merge timestamped "strace -ff"
    log files.
  * Implemented decoding of clock_adjtime, get_robust_list, migrate_pages,
    preadv, prlimit64, process_vm_readv, process_vm_writev, pwritev,
    recvmmsg, recvmsg, rt_tgsigqueueinfo, sendmmsg, setns, set_robust_list,
    sched_rr_get_interval, splice, syslog, tee and vmsplice syscalls.
  * Enhanced decoding of capget, capset, getrlimit, flistxattr, io_submit,
    listxattr, setrlimit and swapon syscalls.
  * Implemented decoding of loop and mtd ioctls.
  * Added syscall entries for new linux syscalls.
  * Added syscall entries for direct socket system calls on powerpc.
  * Updated the list of errno constants.
  * Updated lists of MSG_*, STA_*, and TCP_* constants.
  * Regenerated the list of ioctl names from Linux 3.3.
  * Enhanced switching between processes with different personalities.
  * Enhanced signals reporting by using short signal names.
  * Made ERESTART* messages more descriptive.
  * Made parsing of numbers from strings more robust.
  * Added support for compat_statfs64 and statfs64.f_flags.
  * Changed read of data blocks to use single process_vm_readv syscall
    (when available) instead of several PTRACE_PEEKDATA operations.
  * Changed read of registers on x86 and x86-64 to use single PTRACE_GETREGS
    operation instead of several PTRACE_PEEKUSER operations.
  * Applied various optimizations to make strace work faster.

* Bug fixes
  * Implemented proper handling of real SIGTRAPs on kernels supporting
    PTRACE_O_TRACESYSGOOD.
    (Addresses Fedora bug #162774).
  * Fixed sockaddr_un.sun_path name in decoded output.
    (Addresses Debian bug #554946).
  * Fixed to avoid potential core file clobbering on exit.
    (Addresses Debian bug #656398).
  * Fixed a typo in documentation.
    (Addresses Debian bug #653309).
  * Fixed decoding of timer id returned by timer_create.
  * Fixed epoll_create1, epoll_wait and epoll_pwait decoding.
  * Fixed *at syscalls flags decoding.
  * Fixed ARM EABI 64-bit syscall's arguments decoding.
  * Fixed semtimedop decoding on s390.
  * Fixed osf_sigprocmask decoding on alpha.
  * Fixed ipc and socket subcall decoding on several architectures.
  * Corrected syscall entries for epoll_pwait, epoll_create, epoll_ctl,
    epoll_wait, mincore, mlockall, prctl, reboot, sendfile, sendfile64,
    sendmsg, sgetmask, ssetmask, swapon, tgkill and tkill syscalls.
  * Corrected io_* syscall entries on ARM.
  * Fixed PID prefix printing in "strace -oLOG -ff -p1 -p2 -p3" case.
  * Fixed logging of unfinished lines in "strace -oLOG -ff" case.
  * Fixed build when libaio-devel is not available.
  * Fixed configure checks for PTRACE_* constants.
  * Fixed compilation warnings remained on several architectures.

* Portability
  * Removed all non-Linux code.  After years of neglect, that dead code
    just hampered further strace development.
  * Linux kernel >= 2.6.18 is recommended.  Older versions might still
    work but they haven't been thoroughly tested with this release.

Noteworthy changes in release 4.6 (2011-03-15)
==============================================

* Changes in behavior
  * Print diagnostic information about changes in personality mode to
    standard error instead of standard output.

* Improvements
  * Implemented a new method of following clone, fork, and vfork
    syscalls using the Linux kernel's explicit facilities for tracing
    creation of threads and child processes.
  * Implemented CLONE_PARENT and CLONE_UNTRACED flags handling.
  * Implemented decoding of TLS syscalls on m68k.
  * Implemented biarch support on powerpc64.
  * Implemented biarch support for getrlimit() and setrlimit().
  * Implemented decoding of struct ucred in getsockopt SO_PEERCRED.
  * Implemented SOL_SCTP socket options decoding.
  * Added HDIO_* ioctl names.
    (Addresses Debian bug #450953).
  * Added LOOP_* ioctl names.
  * Updated lists of CLOCK_*, CLONE_*, MS_*, and SOL_* constants
    to match Linux 2.6.37.
  * Updated the list of IPPROTO_* constants to match netinet/in.h.
  * Implemented decoding of HDIO_* and BLK* ioctls.
  * Added MicroBlaze architecture support.
  * Added new syscall entries to match Linux 2.6.37.
  * Regenerated list of ioctl names from Linux 2.6.37.
  * Enhanced signal notification decoding.
  * Documented -C and -D options.

* Bug fixes
  * Fixed fetching syscall arguments on m68k.
  * Fixed an error when judging whether a process has children.
  * Fixed get/set_robust_list syscall numbers for powerpc.
  * Fixed a corner case in printing clone flags.
  * Fixed cross-compiling issues.
  * Fixed build issues on powerpc64, SH and SPARC.
  * Fixed syscall flags of fstatat*, mmap, mmap2, fadvise64*, swapoff,
    fgetxattr, flistxattr, fremovexattr, epoll_create, fallocate,
    fanotify_init, and fanotify_mark syscalls.
  * Fixed decoding of get[ug]id, gete[ug]id and setfs[ug]id return values.
  * Fixed biarch support in IO dumping.
  * Fixed raw exit_group decoding.
  * Fixed decoding of file descriptors on 64-bit architectures.
  * Fixed a corner case in waitpid handling.
    (Addresses Red Hat bug #663547).
  * Fixed stat64 decoding on mips
    (Addresses Debian bug #599028).
  * Fixed misleading italics in the manual page.
    (Addresses Debian bug #589323).

Noteworthy changes in release 4.5.20 (2010-04-13)
=================================================

* Improvements
  * Implemented decoding of new linux syscalls: inotify_init1, recvmmsg.
  * Implemented basic decoding of new linux syscalls: preadv, pwritev,
    rt_tgsigqueueinfo, perf_event_open.
  * Enhanced decoding of recently added syscalls on non-x86 architectures
    by replacing a bare decoder with elaborate parsers enabled earlier
    for x86/x86-64.
  * Implemented -C option to combine regular and -c output.
    (Addresses Debian bug #466196)
  * Enhanced decoding of mbind and mremap syscalls.
  * Enhanced SOL_PACKET socket options decoding.
  * Regenerated list of ioctl names from linux 2.6.33.
  * Added TILE architecture support.

* Bug fixes
  * Fixed build with Linux kernel headers 2.6.32-rc5+.
    (Addresses Debian bug #560516 and Fedora bug #539044)
  * Fixed build on mips.
  * Fixed handling of Linux systems without struct statfs64.
  * Fixed reporting signal mask by sigreturn on powerpc.
  * Fixed potential stack buffer overflow in select decoder.
    (Addresses Fedora bug #556678)
  * Corrected msgsnd indirect ipccall decoding.
  * Corrected decoding of 64bit syscalls.
    (Addresses Debian bug #570603)
  * Corrected getsockopt decoding on architectures where
    sizeof(long) > sizeof(int).
    (Addresses Debian bug #494844)
  * Corrected decoding of epoll_pwait.
    (Addresses Debian bug #513014)
  * Corrected handling of killed threads.

Noteworthy changes in release 4.5.19 (2009-10-21)
=================================================

* Changes in behavior
  * When command exits, strace now exits with the same exit status.
    If command is terminated by a signal, strace terminates itself
    with the same signal, so that strace can be used as a wrapper
    process transparent to the invoking parent process.
    When using -p option, the exit status of strace is zero unless
    there was an unexpected error in doing the tracing.
    (Addresses Fedora bug #105371 and Debian bug #37665)

* Improvements
  * Implemented decoding of new Linux syscalls: accept4, dup3,
    epoll_create1, eventfd2, inotify_init1, pipe2, signalfd4.
  * Implemented decoding of socket type flags introduced in Linux 2.6.27.
  * Implemented decoding of accept4 socketcall.
  * Enhanced prctl decoding.
  * Enhanced nanosleep decoding.
  * Enhanced ptrace decoding.
  * Enhanced futex decoding.
  * Enhanced CAP_* decoding.
  * Enhanced SIOCS* ioctls decoding.
  * Enhanced fcntl F_* flags decoding.
  * Enhanced semop/semtimedop decoding.
  * Updated ARM architecture support.
  * Added Blackfin architecture support.
  * Added AVR32 architecture support.
  * Added CRIS architecture support.
  * Made strace detect when traced process suddenly disappeared.

* Bug fixes
  * Fixed syscall numbers for tee and sync_file_range.
    (Addresses Debian bug #503124)
  * Fixed several bugs in strings decoder, including potential heap
    memory corruption.
    (Addresses Fedora bugs #470529, #478324 and #511035)
  * Marked sendfile(2) as a network syscall.
    (Addresses Debian bug #509499)
  * Fixed accept(2) decoding.
    (Addresses Debian bug #507573)
  * Fixed sigtimedwait(2) decoding.
  * Fixed build on ARM EABI.
    (Addresses Debian bugs #520084 and #535564, and Fedora bug #507576)
  * Fixed display of 32-bit fcntl(F_SETLK) on 64-bit architectures.
    (Addresses Red Hat bug #471169)
  * Fixed display of 32-bit argv array on 64-bit architectures.
    (Addresses Fedora bug #519480)
  * Fixed display of 32-bit struct sigaction on 64-bit architectures.
  * Fixed HPPA architecture support.
    (Addresses Debian bugs #437928 and #546619)

Changes in 4.5.18
==============
* Bug fixes.
* Support new Linux/PPC system call subpage_prot and PROT_SAO flag.
* In sigaction system call, display sa_flags value along with SIG_DFL/SIG_IGN.

Changes in 4.5.17
==============
* Many bug fixes.
* -F is now deprecated, -f has traced vfork too on Linux for a long time now.
* Print O_CLOEXEC, MSG_CMSG_CLOEXEC flag bits.
* Improved output for prctl system call on Linux.
* Improved support for Linux/ARM.
* SA_NOMASK is now spelled SA_NODEFER, and SA_ONESHOT is spelled SA_RESETHAND.

Changes in 4.5.16
==============
* Bug fixes.
* Improved output for delete_module, futex, and mbind system calls on Linux.
* Improved output for SG_IO ioctls on Linux.
* Support new Linux system calls move_pages, utimensat, signalfd, timerfd,
  eventfd, getcpu, epoll_pwait.

Changes in 4.5.15
==============
* Bug fixes.
* Several biarch improvements.
* Improved output for adjtimex, sysctl, quotactl, mount, umount.
* Support new Linux system calls *at, inotify*, pselect6, ppoll and unshare.

Changes in 4.5.14
==============
* Bug fixes.
* Accept numeric system calls in -e.

Changes in 4.5.13
==============
* Bug fixes.
* Introduce "-e trace=desc".

Changes in 4.5.12
==============
* Bug fixes.
* Better x86-64 support for IA32 processes.
* Update PowerPC system calls.
* Better printing for Linux aio system calls.

Changes in 4.5.11
==============
* Quick fix release for build issues.
* One fix for Linux/ARM system call table.

Changes in 4.5.10
==============
* Bug fixes.
* Print fault address for SIGSEGV/SIGBUS signals when available.

Changes in 4.5.9
==============
* Bug fixes.
* Improve socket ioctl printing.
* Update Linux/IA64 syscall list.
* Fix Linux/x86-64 syscall argument extraction for 32-bit processes.
* Improve mount flags printing.
* Support symbolic printing of x86_64 arch_prctl parameters.

Changes in 4.5.8
==============
* Bug fixes.
* Update syscall tables for Alpha, ARM, HPPA.
* Support new Linux syscalls mbind, set_mempolicy, get_mempolicy, waitid.
* Support Linux syscalls fadvise64, fadvise64_64, and epoll_*.
* Improve ioctl command name matching.
* Print RTC_* ioctl structure contents.
* Support newer RLIMIT_* values.
* Print struct cmsghdr details in sendmsg.

Changes in 4.5.7
==============
* Bug fixes.
* Print attribute values in *xattr system calls on Linux.
* Include pread and pwrite calls in -e read and -e write tracing.
* Update SO_* and IP_* value lists and add IPV6_* values for socket options.
* Print clock_t values symbolically in Linux clock_* system calls.

Changes in 4.5.6
==============
* Bug fixes, Linux ioctl updates.
* David Miller contributed support for Linux/SPARC64.

Changes in 4.5.5
==============
* Just bug fixes.

Changes in 4.5.4
==============
* Update Linux ioctl lists.
* Update PF_* and AF_* value lists.
* The 4.5.3 -p behavior for NPTL threads applies only under -f, and got fixed.

Changes in 4.5.3
==============
* Bug fixes.
* On Linux using NPTL threads, -p will now attach to all threads in a process.
* Handle new mq_* system calls in Linux 2.6.6 and later.

Changes in 4.5.2
==============
* Bug fixes.
* Report some new VM_* bit values on Linux.
* Better output for Linux sched_* system calls.

Changes in 4.5.1
==============
* Bug fixes.
* Display multiple ioctl name matches on Linux.

Changes in 4.5
==============
* New port to AMD's x86-64 architecture. One strace binary can
  handle both new x86-64 and old i386 processes.
* Fixed support for LFS64 calls.
* New switch -E to add/remove environment variables for the command.
* Merged s390/s390x port.
* Trace an unbounded number of processes.
* Handle numerous new system calls in Linux 2.5, and new threads semantics.
* Fixed bugs with attach/detach leaving things stopped.
* Fixed traced process seeing ECHILD despite live, traced children
  in waitpid calls with WNOHANG.
* Stuart Menefy contributed a port to Linux/SH.
* Stephen Thomas contributed a port to Linux/SH64.
* Many other bug fixes.

Changes in 4.4
==============
* Fix Linux/ia64 support, looks like someone renamed a few things on us
* Fix the ioctl setup for Linux, turned out it did not really work.
  Improve the ioctl extractor as well so we decode some more ones.

Changes in 4.3.1
================
* compile fixes for Linux/mips

Changes in 4.3
==============
* Linux ia64 and hppa ports added
* The usual Linux syscall updates (includes 32bit uid/gid support),
* Linux ioctl list updated
* Support IPv6 scope ids
* FreeBSD/i386 port added
* UnixWare and Solaris updates
* Better support for tracing multithreaded processes in Linux

Changes in 4.2
==============
* Compiles on glibc2.0 systems again
* Linux/S390 port added
* The usual Linux syscall updates
* we can follow fork on arm now

Changes in 4.1
================
* Linux/MIPS port added
* Lots of Linux updates again
* Improved IPv6 support
* Add strace-graph

Changes in 4.0.1
================
* Minor bugfixes
* Compiles on glibc2.0 systems again

Changes in 4.0
==============
* Get stat structure properly on Linux 64bit archs
* Personalities work again
* Compile correctly on SunOS again
* IRIX64 updates
* Solaris updates

Changes in 3.99.1
=================
* Linux (ultra)sparc fixes
* Linux alpha fixes
* Minor cleanups

Changes in 3.99
===============
* New maintainer
* add support for more Linux architectures (powerpc, sparc, arm)
* support lots more Linux syscalls
* fix signal handling
* add IPX and IPIP support
* check stray syscall after execv
* fix hanging children

Changes in version 3.1
======================

* Irix5 is supported
* Linux 68k is supported
* Linux alpha is supported
* configure is upgraded to autoconf 2.x
* using -f in combination with -e now works correctly
* output can be piped to a program
* tracing setuid programs works better
* it is now reasonable to install strace setuid to root in some circumstances
* new useful tracing names like file and process to trace whole
  classes of system calls, e.g. -efile traces all system calls that
  take a file name as an argument
* IPC calls on SunOS 4.1.x are decoded
* Linux program memory is reliably dereferenced
* Linux decodes at least the name of all syscalls as of pre2.0.4
* various cosmetic changes and bug fixes

Changes from versions 2.x to version 3.0
========================================

* filename arguments are neither abbreviated nor stringified
* string arguments are now true C strings using octal instead of hex by default
* preprocessor constants are never shortened (e.g. was RDONLY => now O_RDONLY)
* by default the output for multiple processes now goes into one file
* all structures, vectors, bitsets, etc. use consistent output formats
* the -c option now means count calls, -i does what the old -c used to do

New Features in version 3.0
===========================

* non-ascii strings can be optionally printed entirely in hex
* the output format is readable when multiple processes are generating output
* exit values are printed in an alignment column
* is is possible to suppress messages about attaching and detaching
* various tracing features can be enabled on a per syscall/signal/desc basis
* selective tracing of syscalls
* selective printing of syscall structures
* selective abbreviation of long structures on a per syscall basis
* selective printing of raw syscall arguments and results
* selective tracing of signals
* selective dumping of all I/O read from file descriptors
* selective dumping of all I/O written to file descriptors
* optional counting of time, calls, and errors for each syscall
